﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Friday, October 17, 2008 5:25:12 PM
// Code is generated using templates: SD.TemplateBindings.SharedTemplates.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using System.ComponentModel;
using System.Collections.Generic;
#if !CF
using System.Runtime.Serialization;
#endif
using System.Xml.Serialization;
using NorthwindAdapter;
using NorthwindAdapter.HelperClasses;
using NorthwindAdapter.FactoryClasses;
using NorthwindAdapter.RelationClasses;

using SD.LLBLGen.Pro.ORMSupportClasses;

namespace NorthwindAdapter.EntityClasses
{
	
	// __LLBLGENPRO_USER_CODE_REGION_START AdditionalNamespaces
	// __LLBLGENPRO_USER_CODE_REGION_END
	

	/// <summary>
	/// Entity class which represents the entity 'Customers'.<br/><br/>
	/// 
	/// </summary>
	[Serializable]
	public partial class CustomersEntity : CommonEntityBase, ISerializable
		// __LLBLGENPRO_USER_CODE_REGION_START AdditionalInterfaces
		// __LLBLGENPRO_USER_CODE_REGION_END
			
	{
		#region Class Member Declarations
		private EntityCollection<CustomerCustomerDemoEntity> _customerCustomerDemo;
		private EntityCollection<OrdersEntity> _orders;
		private EntityCollection<CustomerDemographicsEntity> _customerDemographicsCollectionViaCustomerCustomerDemo;
		private EntityCollection<EmployeesEntity> _employeesCollectionViaOrders;
		private EntityCollection<ShippersEntity> _shippersCollectionViaOrders;


		
		// __LLBLGENPRO_USER_CODE_REGION_START PrivateMembers
		// __LLBLGENPRO_USER_CODE_REGION_END
		
		#endregion

		#region Statics
		private static Dictionary<string, string>	_customProperties;
		private static Dictionary<string, Dictionary<string, string>>	_fieldsCustomProperties;

		/// <summary>All names of fields mapped onto a relation. Usable for in-memory filtering</summary>
		public static class MemberNames
		{

			/// <summary>Member name CustomerCustomerDemo</summary>
			public static readonly string CustomerCustomerDemo = "CustomerCustomerDemo";
			/// <summary>Member name Orders</summary>
			public static readonly string Orders = "Orders";
			/// <summary>Member name CustomerDemographicsCollectionViaCustomerCustomerDemo</summary>
			public static readonly string CustomerDemographicsCollectionViaCustomerCustomerDemo = "CustomerDemographicsCollectionViaCustomerCustomerDemo";
			/// <summary>Member name EmployeesCollectionViaOrders</summary>
			public static readonly string EmployeesCollectionViaOrders = "EmployeesCollectionViaOrders";
			/// <summary>Member name ShippersCollectionViaOrders</summary>
			public static readonly string ShippersCollectionViaOrders = "ShippersCollectionViaOrders";

		}
		#endregion
		
		/// <summary> Static CTor for setting up custom property hashtables. Is executed before the first instance of this entity class or derived classes is constructed. </summary>
		static CustomersEntity()
		{
			SetupCustomPropertyHashtables();
		}

		/// <summary> CTor</summary>
		public CustomersEntity():base("CustomersEntity")
		{
			InitClassEmpty(null, CreateFields());
		}

		/// <summary> CTor</summary>
		/// <remarks>For framework usage.</remarks>
		/// <param name="fields">Fields object to set as the fields for this entity.</param>
		public CustomersEntity(IEntityFields2 fields):base("CustomersEntity")
		{
			InitClassEmpty(null, fields);
		}

		/// <summary> CTor</summary>
		/// <param name="validator">The custom validator object for this CustomersEntity</param>
		public CustomersEntity(IValidator validator):base("CustomersEntity")
		{
			InitClassEmpty(validator, CreateFields());
		}
				

		/// <summary> CTor</summary>
		/// <param name="customerId">PK value for Customers which data should be fetched into this Customers object</param>
		/// <remarks>The entity is not fetched by this constructor. Use a DataAccessAdapter for that.</remarks>
		public CustomersEntity(System.String customerId):base("CustomersEntity")
		{
			InitClassEmpty(null, CreateFields());
			this.CustomerId = customerId;
		}

		/// <summary> CTor</summary>
		/// <param name="customerId">PK value for Customers which data should be fetched into this Customers object</param>
		/// <param name="validator">The custom validator object for this CustomersEntity</param>
		/// <remarks>The entity is not fetched by this constructor. Use a DataAccessAdapter for that.</remarks>
		public CustomersEntity(System.String customerId, IValidator validator):base("CustomersEntity")
		{
			InitClassEmpty(validator, CreateFields());
			this.CustomerId = customerId;
		}

		/// <summary> Protected CTor for deserialization</summary>
		/// <param name="info"></param>
		/// <param name="context"></param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		protected CustomersEntity(SerializationInfo info, StreamingContext context) : base(info, context)
		{
			if(SerializationHelper.Optimization != SerializationOptimization.Fast) 
			{
				_customerCustomerDemo = (EntityCollection<CustomerCustomerDemoEntity>)info.GetValue("_customerCustomerDemo", typeof(EntityCollection<CustomerCustomerDemoEntity>));
				_orders = (EntityCollection<OrdersEntity>)info.GetValue("_orders", typeof(EntityCollection<OrdersEntity>));
				_customerDemographicsCollectionViaCustomerCustomerDemo = (EntityCollection<CustomerDemographicsEntity>)info.GetValue("_customerDemographicsCollectionViaCustomerCustomerDemo", typeof(EntityCollection<CustomerDemographicsEntity>));
				_employeesCollectionViaOrders = (EntityCollection<EmployeesEntity>)info.GetValue("_employeesCollectionViaOrders", typeof(EntityCollection<EmployeesEntity>));
				_shippersCollectionViaOrders = (EntityCollection<ShippersEntity>)info.GetValue("_shippersCollectionViaOrders", typeof(EntityCollection<ShippersEntity>));


				base.FixupDeserialization(FieldInfoProviderSingleton.GetInstance());
			}
			
			// __LLBLGENPRO_USER_CODE_REGION_START DeserializationConstructor
			// __LLBLGENPRO_USER_CODE_REGION_END
			
		}

		
		/// <summary>Performs the desync setup when an FK field has been changed. The entity referenced based on the FK field will be dereferenced and sync info will be removed.</summary>
		/// <param name="fieldIndex">The fieldindex.</param>
		protected override void PerformDesyncSetupFKFieldChange(int fieldIndex)
		{
			switch((CustomersFieldIndex)fieldIndex)
			{
				default:
					base.PerformDesyncSetupFKFieldChange(fieldIndex);
					break;
			}
		}
				
		/// <summary>Gets the inheritance info provider instance of the project this entity instance is located in. </summary>
		/// <returns>ready to use inheritance info provider instance.</returns>
		protected override IInheritanceInfoProvider GetInheritanceInfoProvider()
		{
			return InheritanceInfoProviderSingleton.GetInstance();
		}
		
		/// <summary> Sets the related entity property to the entity specified. If the property is a collection, it will add the entity specified to that collection.</summary>
		/// <param name="propertyName">Name of the property.</param>
		/// <param name="entity">Entity to set as an related entity</param>
		/// <remarks>Used by prefetch path logic.</remarks>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public override void SetRelatedEntityProperty(string propertyName, IEntity2 entity)
		{
			switch(propertyName)
			{

				case "CustomerCustomerDemo":
					this.CustomerCustomerDemo.Add((CustomerCustomerDemoEntity)entity);
					break;
				case "Orders":
					this.Orders.Add((OrdersEntity)entity);
					break;
				case "CustomerDemographicsCollectionViaCustomerCustomerDemo":
					this.CustomerDemographicsCollectionViaCustomerCustomerDemo.IsReadOnly = false;
					this.CustomerDemographicsCollectionViaCustomerCustomerDemo.Add((CustomerDemographicsEntity)entity);
					this.CustomerDemographicsCollectionViaCustomerCustomerDemo.IsReadOnly = true;
					break;
				case "EmployeesCollectionViaOrders":
					this.EmployeesCollectionViaOrders.IsReadOnly = false;
					this.EmployeesCollectionViaOrders.Add((EmployeesEntity)entity);
					this.EmployeesCollectionViaOrders.IsReadOnly = true;
					break;
				case "ShippersCollectionViaOrders":
					this.ShippersCollectionViaOrders.IsReadOnly = false;
					this.ShippersCollectionViaOrders.Add((ShippersEntity)entity);
					this.ShippersCollectionViaOrders.IsReadOnly = true;
					break;

				default:
					break;
			}
		}
		
		/// <summary>Gets the relation objects which represent the relation the fieldName specified is mapped on. </summary>
		/// <param name="fieldName">Name of the field mapped onto the relation of which the relation objects have to be obtained.</param>
		/// <returns>RelationCollection with relation object(s) which represent the relation the field is maped on</returns>
		public override RelationCollection GetRelationsForFieldOfType(string fieldName)
		{
			return CustomersEntity.GetRelationsForField(fieldName);
		}

		/// <summary>Gets the relation objects which represent the relation the fieldName specified is mapped on. </summary>
		/// <param name="fieldName">Name of the field mapped onto the relation of which the relation objects have to be obtained.</param>
		/// <returns>RelationCollection with relation object(s) which represent the relation the field is maped on</returns>
		public static RelationCollection GetRelationsForField(string fieldName)
		{
			RelationCollection toReturn = new RelationCollection();
			switch(fieldName)
			{

				case "CustomerCustomerDemo":
					toReturn.Add(CustomersEntity.Relations.CustomerCustomerDemoEntityUsingCustomerId);
					break;
				case "Orders":
					toReturn.Add(CustomersEntity.Relations.OrdersEntityUsingCustomerId);
					break;
				case "CustomerDemographicsCollectionViaCustomerCustomerDemo":
					toReturn.Add(CustomersEntity.Relations.CustomerCustomerDemoEntityUsingCustomerId, "CustomersEntity__", "CustomerCustomerDemo_", JoinHint.None);
					toReturn.Add(CustomerCustomerDemoEntity.Relations.CustomerDemographicsEntityUsingCustomerTypeId, "CustomerCustomerDemo_", string.Empty, JoinHint.None);
					break;
				case "EmployeesCollectionViaOrders":
					toReturn.Add(CustomersEntity.Relations.OrdersEntityUsingCustomerId, "CustomersEntity__", "Orders_", JoinHint.None);
					toReturn.Add(OrdersEntity.Relations.EmployeesEntityUsingEmployeeId, "Orders_", string.Empty, JoinHint.None);
					break;
				case "ShippersCollectionViaOrders":
					toReturn.Add(CustomersEntity.Relations.OrdersEntityUsingCustomerId, "CustomersEntity__", "Orders_", JoinHint.None);
					toReturn.Add(OrdersEntity.Relations.ShippersEntityUsingShipVia, "Orders_", string.Empty, JoinHint.None);
					break;

				default:

					break;				
			}
			return toReturn;
		}
#if !CF
		/// <summary>Checks if the relation mapped by the property with the name specified is a one way / single sided relation. If the passed in name is null, it
		/// will return true if the entity has any single-sided relation</summary>
		/// <param name="propertyName">Name of the property which is mapped onto the relation to check, or null to check if the entity has any relation/ which is single sided</param>
		/// <returns>true if the relation is single sided / one way (so the opposite relation isn't present), false otherwise</returns>
		[EditorBrowsable(EditorBrowsableState.Never)]
		protected override bool CheckOneWayRelations(string propertyName)
		{
			// use template trick to calculate the # of single-sided / oneway relations
			int numberOfOneWayRelations = 0;
			switch(propertyName)
			{
				case null:
					return ((numberOfOneWayRelations > 0) || base.CheckOneWayRelations(null));


				default:
					return base.CheckOneWayRelations(propertyName);
			}
		}
#endif
		/// <summary> Sets the internal parameter related to the fieldname passed to the instance relatedEntity. </summary>
		/// <param name="relatedEntity">Instance to set as the related entity of type entityType</param>
		/// <param name="fieldName">Name of field mapped onto the relation which resolves in the instance relatedEntity</param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public override void SetRelatedEntity(IEntity2 relatedEntity, string fieldName)
		{
			switch(fieldName)
			{

				case "CustomerCustomerDemo":
					this.CustomerCustomerDemo.Add((CustomerCustomerDemoEntity)relatedEntity);
					break;
				case "Orders":
					this.Orders.Add((OrdersEntity)relatedEntity);
					break;

				default:
					break;
			}
		}

		/// <summary> Unsets the internal parameter related to the fieldname passed to the instance relatedEntity. Reverses the actions taken by SetRelatedEntity() </summary>
		/// <param name="relatedEntity">Instance to unset as the related entity of type entityType</param>
		/// <param name="fieldName">Name of field mapped onto the relation which resolves in the instance relatedEntity</param>
		/// <param name="signalRelatedEntityManyToOne">if set to true it will notify the manytoone side, if applicable.</param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public override void UnsetRelatedEntity(IEntity2 relatedEntity, string fieldName, bool signalRelatedEntityManyToOne)
		{
			switch(fieldName)
			{

				case "CustomerCustomerDemo":
					base.PerformRelatedEntityRemoval(this.CustomerCustomerDemo, relatedEntity, signalRelatedEntityManyToOne);
					break;
				case "Orders":
					base.PerformRelatedEntityRemoval(this.Orders, relatedEntity, signalRelatedEntityManyToOne);
					break;

				default:
					break;
			}
		}

		/// <summary> Gets a collection of related entities referenced by this entity which depend on this entity (this entity is the PK side of their FK fields). These entities will have to be persisted after this entity during a recursive save.</summary>
		/// <returns>Collection with 0 or more IEntity2 objects, referenced by this entity</returns>
		public override List<IEntity2> GetDependingRelatedEntities()
		{
			List<IEntity2> toReturn = new List<IEntity2>();

			return toReturn;
		}
		
		/// <summary> Gets a collection of related entities referenced by this entity which this entity depends on (this entity is the FK side of their PK fields). These
		/// entities will have to be persisted before this entity during a recursive save.</summary>
		/// <returns>Collection with 0 or more IEntity2 objects, referenced by this entity</returns>
		public override List<IEntity2> GetDependentRelatedEntities()
		{
			List<IEntity2> toReturn = new List<IEntity2>();


			return toReturn;
		}
		
		/// <summary>Gets a list of all entity collections stored as member variables in this entity. The contents of the ArrayList is used by the DataAccessAdapter to perform recursive saves. Only 1:n related collections are returned.</summary>
		/// <returns>Collection with 0 or more IEntityCollection2 objects, referenced by this entity</returns>
		public override List<IEntityCollection2> GetMemberEntityCollections()
		{
			List<IEntityCollection2> toReturn = new List<IEntityCollection2>();
			toReturn.Add(this.CustomerCustomerDemo);
			toReturn.Add(this.Orders);

			return toReturn;
		}
		


		/// <summary>ISerializable member. Does custom serialization so event handlers do not get serialized. Serializes members of this entity class and uses the base class' implementation to serialize the rest.</summary>
		/// <param name="info"></param>
		/// <param name="context"></param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			if (SerializationHelper.Optimization != SerializationOptimization.Fast) 
			{
				info.AddValue("_customerCustomerDemo", ((_customerCustomerDemo!=null) && (_customerCustomerDemo.Count>0) && !this.MarkedForDeletion)?_customerCustomerDemo:null);
				info.AddValue("_orders", ((_orders!=null) && (_orders.Count>0) && !this.MarkedForDeletion)?_orders:null);
				info.AddValue("_customerDemographicsCollectionViaCustomerCustomerDemo", ((_customerDemographicsCollectionViaCustomerCustomerDemo!=null) && (_customerDemographicsCollectionViaCustomerCustomerDemo.Count>0) && !this.MarkedForDeletion)?_customerDemographicsCollectionViaCustomerCustomerDemo:null);
				info.AddValue("_employeesCollectionViaOrders", ((_employeesCollectionViaOrders!=null) && (_employeesCollectionViaOrders.Count>0) && !this.MarkedForDeletion)?_employeesCollectionViaOrders:null);
				info.AddValue("_shippersCollectionViaOrders", ((_shippersCollectionViaOrders!=null) && (_shippersCollectionViaOrders.Count>0) && !this.MarkedForDeletion)?_shippersCollectionViaOrders:null);


			}
			
			// __LLBLGENPRO_USER_CODE_REGION_START GetObjectInfo
			// __LLBLGENPRO_USER_CODE_REGION_END
			
			base.GetObjectData(info, context);
		}

		/// <summary>Returns true if the original value for the field with the fieldIndex passed in, read from the persistent storage was NULL, false otherwise.
		/// Should not be used for testing if the current value is NULL, use <see cref="TestCurrentFieldValueForNull"/> for that.</summary>
		/// <param name="fieldIndex">Index of the field to test if that field was NULL in the persistent storage</param>
		/// <returns>true if the field with the passed in index was NULL in the persistent storage, false otherwise</returns>
		public bool TestOriginalFieldValueForNull(CustomersFieldIndex fieldIndex)
		{
			return base.Fields[(int)fieldIndex].IsNull;
		}
		
		/// <summary>Returns true if the current value for the field with the fieldIndex passed in represents null/not defined, false otherwise.
		/// Should not be used for testing if the original value (read from the db) is NULL</summary>
		/// <param name="fieldIndex">Index of the field to test if its currentvalue is null/undefined</param>
		/// <returns>true if the field's value isn't defined yet, false otherwise</returns>
		public bool TestCurrentFieldValueForNull(CustomersFieldIndex fieldIndex)
		{
			return base.CheckIfCurrentFieldValueIsNull((int)fieldIndex);
		}

				
		/// <summary>Gets a list of all the EntityRelation objects the type of this instance has.</summary>
		/// <returns>A list of all the EntityRelation objects the type of this instance has. Hierarchy relations are excluded.</returns>
		public override List<IEntityRelation> GetAllRelations()
		{
			return new CustomersRelations().GetAllRelations();
		}
		

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'CustomerCustomerDemo' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoCustomerCustomerDemo()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(CustomerCustomerDemoFields.CustomerId, null, ComparisonOperator.Equal, this.CustomerId));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'Orders' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoOrders()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(OrdersFields.CustomerId, null, ComparisonOperator.Equal, this.CustomerId));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'CustomerDemographics' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoCustomerDemographicsCollectionViaCustomerCustomerDemo()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.Relations.AddRange(GetRelationsForFieldOfType("CustomerDemographicsCollectionViaCustomerCustomerDemo"));
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(CustomersFields.CustomerId, null, ComparisonOperator.Equal, this.CustomerId, "CustomersEntity__"));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'Employees' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoEmployeesCollectionViaOrders()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.Relations.AddRange(GetRelationsForFieldOfType("EmployeesCollectionViaOrders"));
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(CustomersFields.CustomerId, null, ComparisonOperator.Equal, this.CustomerId, "CustomersEntity__"));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'Shippers' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoShippersCollectionViaOrders()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.Relations.AddRange(GetRelationsForFieldOfType("ShippersCollectionViaOrders"));
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(CustomersFields.CustomerId, null, ComparisonOperator.Equal, this.CustomerId, "CustomersEntity__"));
			return bucket;
		}


	
		
		/// <summary>Creates entity fields object for this entity. Used in constructor to setup this entity in a polymorphic scenario.</summary>
		protected virtual IEntityFields2 CreateFields()
		{
			return EntityFieldsFactory.CreateEntityFieldsObject(NorthwindAdapter.EntityType.CustomersEntity);
		}

		/// <summary>
		/// Creates the ITypeDefaultValue instance used to provide default values for value types which aren't of type nullable(of T)
		/// </summary>
		/// <returns></returns>
		protected override ITypeDefaultValue CreateTypeDefaultValueProvider()
		{
			return new TypeDefaultValue();
		}

		/// <summary>Creates a new instance of the factory related to this entity</summary>
		protected override IEntityFactory2 CreateEntityFactory()
		{
			return EntityFactoryCache2.GetEntityFactory(typeof(CustomersEntityFactory));
		}
#if !CF
		/// <summary>Adds the member collections to the collections queue (base first)</summary>
		/// <param name="collectionsQueue">The collections queue.</param>
		protected override void AddToMemberEntityCollectionsQueue(Queue<IEntityCollection2> collectionsQueue) 
		{
			base.AddToMemberEntityCollectionsQueue(collectionsQueue);
			collectionsQueue.Enqueue(this._customerCustomerDemo);
			collectionsQueue.Enqueue(this._orders);
			collectionsQueue.Enqueue(this._customerDemographicsCollectionViaCustomerCustomerDemo);
			collectionsQueue.Enqueue(this._employeesCollectionViaOrders);
			collectionsQueue.Enqueue(this._shippersCollectionViaOrders);
		}
		
		/// <summary>Gets the member collections queue from the queue (base first)</summary>
		/// <param name="collectionsQueue">The collections queue.</param>
		protected override void GetFromMemberEntityCollectionsQueue(Queue<IEntityCollection2> collectionsQueue)
		{
			base.GetFromMemberEntityCollectionsQueue(collectionsQueue);
			this._customerCustomerDemo = (EntityCollection<CustomerCustomerDemoEntity>) collectionsQueue.Dequeue();
			this._orders = (EntityCollection<OrdersEntity>) collectionsQueue.Dequeue();
			this._customerDemographicsCollectionViaCustomerCustomerDemo = (EntityCollection<CustomerDemographicsEntity>) collectionsQueue.Dequeue();
			this._employeesCollectionViaOrders = (EntityCollection<EmployeesEntity>) collectionsQueue.Dequeue();
			this._shippersCollectionViaOrders = (EntityCollection<ShippersEntity>) collectionsQueue.Dequeue();
		}
		
		/// <summary>Determines whether the entity has populated member collections</summary>
		/// <returns>true if the entity has populated member collections.</returns>
		protected override bool HasPopulatedMemberEntityCollections()
		{
			if (this._customerCustomerDemo != null)
			{
				return true;
			}
			if (this._orders != null)
			{
				return true;
			}
			if (this._customerDemographicsCollectionViaCustomerCustomerDemo != null)
			{
				return true;
			}
			if (this._employeesCollectionViaOrders != null)
			{
				return true;
			}
			if (this._shippersCollectionViaOrders != null)
			{
				return true;
			}
			return base.HasPopulatedMemberEntityCollections();
		}
		
		/// <summary>Creates the member entity collections queue.</summary>
		/// <param name="collectionsQueue">The collections queue.</param>
		/// <param name="requiredQueue">The required queue.</param>
		protected override void CreateMemberEntityCollectionsQueue(Queue<IEntityCollection2> collectionsQueue, Queue<bool> requiredQueue) 
		{
			base.CreateMemberEntityCollectionsQueue(collectionsQueue, requiredQueue);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<CustomerCustomerDemoEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CustomerCustomerDemoEntityFactory))) : null);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<OrdersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(OrdersEntityFactory))) : null);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<CustomerDemographicsEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CustomerDemographicsEntityFactory))) : null);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<EmployeesEntity>(EntityFactoryCache2.GetEntityFactory(typeof(EmployeesEntityFactory))) : null);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<ShippersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(ShippersEntityFactory))) : null);
		}
#endif
		/// <summary>
		/// Gets all related data objects, stored by name. The name is the field name mapped onto the relation for that particular data element. 
		/// </summary>
		/// <returns>Dictionary with per name the related referenced data element, which can be an entity collection or an entity or null</returns>
		public override Dictionary<string, object> GetRelatedData()
		{
			Dictionary<string, object> toReturn = new Dictionary<string, object>();

			toReturn.Add("CustomerCustomerDemo", _customerCustomerDemo);
			toReturn.Add("Orders", _orders);
			toReturn.Add("CustomerDemographicsCollectionViaCustomerCustomerDemo", _customerDemographicsCollectionViaCustomerCustomerDemo);
			toReturn.Add("EmployeesCollectionViaOrders", _employeesCollectionViaOrders);
			toReturn.Add("ShippersCollectionViaOrders", _shippersCollectionViaOrders);

			return toReturn;
		}
		
		/// <summary> Adds the internals to the active context. </summary>
		protected override void AddInternalsToContext()
		{
			if(_customerCustomerDemo!=null)
			{
				_customerCustomerDemo.ActiveContext = base.ActiveContext;
			}
			if(_orders!=null)
			{
				_orders.ActiveContext = base.ActiveContext;
			}
			if(_customerDemographicsCollectionViaCustomerCustomerDemo!=null)
			{
				_customerDemographicsCollectionViaCustomerCustomerDemo.ActiveContext = base.ActiveContext;
			}
			if(_employeesCollectionViaOrders!=null)
			{
				_employeesCollectionViaOrders.ActiveContext = base.ActiveContext;
			}
			if(_shippersCollectionViaOrders!=null)
			{
				_shippersCollectionViaOrders.ActiveContext = base.ActiveContext;
			}


		}

		/// <summary> Initializes the class members</summary>
		protected virtual void InitClassMembers()
		{

			_customerCustomerDemo = null;
			_orders = null;
			_customerDemographicsCollectionViaCustomerCustomerDemo = null;
			_employeesCollectionViaOrders = null;
			_shippersCollectionViaOrders = null;


			PerformDependencyInjection();
			
			// __LLBLGENPRO_USER_CODE_REGION_START InitClassMembers
			// __LLBLGENPRO_USER_CODE_REGION_END
			
			OnInitClassMembersComplete();
		}

		#region Custom Property Hashtable Setup
		/// <summary> Initializes the hashtables for the entity type and entity field custom properties. </summary>
		private static void SetupCustomPropertyHashtables()
		{
			_customProperties = new Dictionary<string, string>();
			_fieldsCustomProperties = new Dictionary<string, Dictionary<string, string>>();

			Dictionary<string, string> fieldHashtable = null;
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("CustomerId", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("CompanyName", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("ContactName", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("ContactTitle", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Address", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("City", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Region", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("PostalCode", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Country", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Phone", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Fax", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Bool", fieldHashtable);
		}
		#endregion



		/// <summary> Initializes the class with empty data, as if it is a new Entity.</summary>
		/// <param name="validator">The validator object for this CustomersEntity</param>
		/// <param name="fields">Fields of this entity</param>
		protected virtual void InitClassEmpty(IValidator validator, IEntityFields2 fields)
		{
			OnInitializing();
			base.Fields = fields;
			base.IsNew=true;
			base.Validator = validator;
			InitClassMembers();

			
			// __LLBLGENPRO_USER_CODE_REGION_START InitClassEmpty
			// __LLBLGENPRO_USER_CODE_REGION_END
			

			OnInitialized();
		}

		#region Class Property Declarations
		/// <summary> The relations object holding all relations of this entity with other entity classes.</summary>
		public  static CustomersRelations Relations
		{
			get	{ return new CustomersRelations(); }
		}
		
		/// <summary> The custom properties for this entity type.</summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		public  static Dictionary<string, string> CustomProperties
		{
			get { return _customProperties;}
		}

		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'CustomerCustomerDemo' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathCustomerCustomerDemo
		{
			get
			{
				return new PrefetchPathElement2( new EntityCollection<CustomerCustomerDemoEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CustomerCustomerDemoEntityFactory))),
					(IEntityRelation)GetRelationsForField("CustomerCustomerDemo")[0], (int)NorthwindAdapter.EntityType.CustomersEntity, (int)NorthwindAdapter.EntityType.CustomerCustomerDemoEntity, 0, null, null, null, null, "CustomerCustomerDemo", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany);
			}
		}
		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'Orders' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathOrders
		{
			get
			{
				return new PrefetchPathElement2( new EntityCollection<OrdersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(OrdersEntityFactory))),
					(IEntityRelation)GetRelationsForField("Orders")[0], (int)NorthwindAdapter.EntityType.CustomersEntity, (int)NorthwindAdapter.EntityType.OrdersEntity, 0, null, null, null, null, "Orders", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany);
			}
		}

		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'CustomerDemographics' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathCustomerDemographicsCollectionViaCustomerCustomerDemo
		{
			get
			{
				IEntityRelation intermediateRelation = CustomersEntity.Relations.CustomerCustomerDemoEntityUsingCustomerId;
				intermediateRelation.SetAliases(string.Empty, "CustomerCustomerDemo_");
				return new PrefetchPathElement2(new EntityCollection<CustomerDemographicsEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CustomerDemographicsEntityFactory))), intermediateRelation,
					(int)NorthwindAdapter.EntityType.CustomersEntity, (int)NorthwindAdapter.EntityType.CustomerDemographicsEntity, 0, null, null, GetRelationsForField("CustomerDemographicsCollectionViaCustomerCustomerDemo"), null, "CustomerDemographicsCollectionViaCustomerCustomerDemo", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToMany);
			}
		}

		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'Employees' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathEmployeesCollectionViaOrders
		{
			get
			{
				IEntityRelation intermediateRelation = CustomersEntity.Relations.OrdersEntityUsingCustomerId;
				intermediateRelation.SetAliases(string.Empty, "Orders_");
				return new PrefetchPathElement2(new EntityCollection<EmployeesEntity>(EntityFactoryCache2.GetEntityFactory(typeof(EmployeesEntityFactory))), intermediateRelation,
					(int)NorthwindAdapter.EntityType.CustomersEntity, (int)NorthwindAdapter.EntityType.EmployeesEntity, 0, null, null, GetRelationsForField("EmployeesCollectionViaOrders"), null, "EmployeesCollectionViaOrders", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToMany);
			}
		}

		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'Shippers' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathShippersCollectionViaOrders
		{
			get
			{
				IEntityRelation intermediateRelation = CustomersEntity.Relations.OrdersEntityUsingCustomerId;
				intermediateRelation.SetAliases(string.Empty, "Orders_");
				return new PrefetchPathElement2(new EntityCollection<ShippersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(ShippersEntityFactory))), intermediateRelation,
					(int)NorthwindAdapter.EntityType.CustomersEntity, (int)NorthwindAdapter.EntityType.ShippersEntity, 0, null, null, GetRelationsForField("ShippersCollectionViaOrders"), null, "ShippersCollectionViaOrders", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToMany);
			}
		}



		/// <summary> The custom properties for the type of this entity instance.</summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		[Browsable(false), XmlIgnore]
		public override Dictionary<string, string> CustomPropertiesOfType
		{
			get { return CustomersEntity.CustomProperties;}
		}

		/// <summary> The custom properties for the fields of this entity type. The returned Hashtable contains per fieldname a hashtable of name-value
		/// pairs. </summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		public  static Dictionary<string, Dictionary<string, string>> FieldsCustomProperties
		{
			get { return _fieldsCustomProperties;}
		}

		/// <summary> The custom properties for the fields of the type of this entity instance. The returned Hashtable contains per fieldname a hashtable of name-value pairs. </summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		[Browsable(false), XmlIgnore]
		public override Dictionary<string, Dictionary<string, string>> FieldsCustomPropertiesOfType
		{
			get { return CustomersEntity.FieldsCustomProperties;}
		}

		/// <summary> The CustomerId property of the Entity Customers<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Customers"."CustomerID"<br/>
		/// Table field type characteristics (type, precision, scale, length): NChar, 0, 0, 5<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): false, true, false</remarks>
		public virtual System.String CustomerId
		{
			get { return (System.String)GetValue((int)CustomersFieldIndex.CustomerId, true); }
			set	{ SetValue((int)CustomersFieldIndex.CustomerId, value); }
		}

		/// <summary> The CompanyName property of the Entity Customers<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Customers"."CompanyName"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 40<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): false, false, false</remarks>
		public virtual System.String CompanyName
		{
			get { return (System.String)GetValue((int)CustomersFieldIndex.CompanyName, true); }
			set	{ SetValue((int)CustomersFieldIndex.CompanyName, value); }
		}

		/// <summary> The ContactName property of the Entity Customers<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Customers"."ContactName"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 30<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String ContactName
		{
			get { return (System.String)GetValue((int)CustomersFieldIndex.ContactName, true); }
			set	{ SetValue((int)CustomersFieldIndex.ContactName, value); }
		}

		/// <summary> The ContactTitle property of the Entity Customers<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Customers"."ContactTitle"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 30<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String ContactTitle
		{
			get { return (System.String)GetValue((int)CustomersFieldIndex.ContactTitle, true); }
			set	{ SetValue((int)CustomersFieldIndex.ContactTitle, value); }
		}

		/// <summary> The Address property of the Entity Customers<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Customers"."Address"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 60<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String Address
		{
			get { return (System.String)GetValue((int)CustomersFieldIndex.Address, true); }
			set	{ SetValue((int)CustomersFieldIndex.Address, value); }
		}

		/// <summary> The City property of the Entity Customers<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Customers"."City"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 15<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String City
		{
			get { return (System.String)GetValue((int)CustomersFieldIndex.City, true); }
			set	{ SetValue((int)CustomersFieldIndex.City, value); }
		}

		/// <summary> The Region property of the Entity Customers<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Customers"."Region"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 15<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String Region
		{
			get { return (System.String)GetValue((int)CustomersFieldIndex.Region, true); }
			set	{ SetValue((int)CustomersFieldIndex.Region, value); }
		}

		/// <summary> The PostalCode property of the Entity Customers<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Customers"."PostalCode"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 10<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String PostalCode
		{
			get { return (System.String)GetValue((int)CustomersFieldIndex.PostalCode, true); }
			set	{ SetValue((int)CustomersFieldIndex.PostalCode, value); }
		}

		/// <summary> The Country property of the Entity Customers<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Customers"."Country"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 15<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String Country
		{
			get { return (System.String)GetValue((int)CustomersFieldIndex.Country, true); }
			set	{ SetValue((int)CustomersFieldIndex.Country, value); }
		}

		/// <summary> The Phone property of the Entity Customers<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Customers"."Phone"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 24<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String Phone
		{
			get { return (System.String)GetValue((int)CustomersFieldIndex.Phone, true); }
			set	{ SetValue((int)CustomersFieldIndex.Phone, value); }
		}

		/// <summary> The Fax property of the Entity Customers<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Customers"."Fax"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 24<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String Fax
		{
			get { return (System.String)GetValue((int)CustomersFieldIndex.Fax, true); }
			set	{ SetValue((int)CustomersFieldIndex.Fax, value); }
		}

		/// <summary> The Bool property of the Entity Customers<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Customers"."Bool"<br/>
		/// Table field type characteristics (type, precision, scale, length): Bit, 0, 0, 0<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual Nullable<System.Boolean> Bool
		{
			get { return (Nullable<System.Boolean>)GetValue((int)CustomersFieldIndex.Bool, false); }
			set	{ SetValue((int)CustomersFieldIndex.Bool, value); }
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'CustomerCustomerDemoEntity' which are related to this entity via a relation of type '1:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(CustomerCustomerDemoEntity))]
		public virtual EntityCollection<CustomerCustomerDemoEntity> CustomerCustomerDemo
		{
			get
			{
				if(_customerCustomerDemo==null)
				{
					_customerCustomerDemo = new EntityCollection<CustomerCustomerDemoEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CustomerCustomerDemoEntityFactory)));
					_customerCustomerDemo.SetContainingEntityInfo(this, "Customers");
				}
				return _customerCustomerDemo;
			}
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'OrdersEntity' which are related to this entity via a relation of type '1:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(OrdersEntity))]
		public virtual EntityCollection<OrdersEntity> Orders
		{
			get
			{
				if(_orders==null)
				{
					_orders = new EntityCollection<OrdersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(OrdersEntityFactory)));
					_orders.SetContainingEntityInfo(this, "Customers");
				}
				return _orders;
			}
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'CustomerDemographicsEntity' which are related to this entity via a relation of type 'm:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(CustomerDemographicsEntity))]
		public virtual EntityCollection<CustomerDemographicsEntity> CustomerDemographicsCollectionViaCustomerCustomerDemo
		{
			get
			{
				if(_customerDemographicsCollectionViaCustomerCustomerDemo==null)
				{
					_customerDemographicsCollectionViaCustomerCustomerDemo = new EntityCollection<CustomerDemographicsEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CustomerDemographicsEntityFactory)));
					_customerDemographicsCollectionViaCustomerCustomerDemo.IsReadOnly=true;
				}
				return _customerDemographicsCollectionViaCustomerCustomerDemo;
			}
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'EmployeesEntity' which are related to this entity via a relation of type 'm:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(EmployeesEntity))]
		public virtual EntityCollection<EmployeesEntity> EmployeesCollectionViaOrders
		{
			get
			{
				if(_employeesCollectionViaOrders==null)
				{
					_employeesCollectionViaOrders = new EntityCollection<EmployeesEntity>(EntityFactoryCache2.GetEntityFactory(typeof(EmployeesEntityFactory)));
					_employeesCollectionViaOrders.IsReadOnly=true;
				}
				return _employeesCollectionViaOrders;
			}
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'ShippersEntity' which are related to this entity via a relation of type 'm:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(ShippersEntity))]
		public virtual EntityCollection<ShippersEntity> ShippersCollectionViaOrders
		{
			get
			{
				if(_shippersCollectionViaOrders==null)
				{
					_shippersCollectionViaOrders = new EntityCollection<ShippersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(ShippersEntityFactory)));
					_shippersCollectionViaOrders.IsReadOnly=true;
				}
				return _shippersCollectionViaOrders;
			}
		}


	
		
		/// <summary> Gets the type of the hierarchy this entity is in. </summary>
		protected override InheritanceHierarchyType LLBLGenProIsInHierarchyOfType
		{
			get { return InheritanceHierarchyType.None;}
		}
		
		/// <summary> Gets or sets a value indicating whether this entity is a subtype</summary>
		protected override bool LLBLGenProIsSubType
		{
			get { return false;}
		}
		
		/// <summary>Returns the NorthwindAdapter.EntityType enum value for this entity.</summary>
		[Browsable(false), XmlIgnore]
		public override int LLBLGenProEntityTypeValue 
		{ 
			get { return (int)NorthwindAdapter.EntityType.CustomersEntity; }
		}
		#endregion


		#region Custom Entity code
		
		// __LLBLGENPRO_USER_CODE_REGION_START CustomEntityCode
		// __LLBLGENPRO_USER_CODE_REGION_END
		
		#endregion

		#region Included code

		#endregion
	}
}
