﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Friday, October 17, 2008 5:25:12 PM
// Code is generated using templates: SD.TemplateBindings.SharedTemplates.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using System.ComponentModel;
using System.Collections.Generic;
#if !CF
using System.Runtime.Serialization;
#endif
using System.Xml.Serialization;
using NorthwindAdapter;
using NorthwindAdapter.HelperClasses;
using NorthwindAdapter.FactoryClasses;
using NorthwindAdapter.RelationClasses;

using SD.LLBLGen.Pro.ORMSupportClasses;

namespace NorthwindAdapter.EntityClasses
{
	
	// __LLBLGENPRO_USER_CODE_REGION_START AdditionalNamespaces
	// __LLBLGENPRO_USER_CODE_REGION_END
	

	/// <summary>
	/// Entity class which represents the entity 'Employees'.<br/><br/>
	/// 
	/// </summary>
	[Serializable]
	public partial class EmployeesEntity : CommonEntityBase, ISerializable
		// __LLBLGENPRO_USER_CODE_REGION_START AdditionalInterfaces
		// __LLBLGENPRO_USER_CODE_REGION_END
			
	{
		#region Class Member Declarations
		private EntityCollection<EmployeesEntity> _employees_;
		private EntityCollection<EmployeeTerritoriesEntity> _employeeTerritories;
		private EntityCollection<OrdersEntity> _orders;
		private EntityCollection<CustomersEntity> _customersCollectionViaOrders;
		private EntityCollection<ShippersEntity> _shippersCollectionViaOrders;
		private EntityCollection<TerritoriesEntity> _territoriesCollectionViaEmployeeTerritories;
		private EmployeesEntity _employees;

		
		// __LLBLGENPRO_USER_CODE_REGION_START PrivateMembers
		// __LLBLGENPRO_USER_CODE_REGION_END
		
		#endregion

		#region Statics
		private static Dictionary<string, string>	_customProperties;
		private static Dictionary<string, Dictionary<string, string>>	_fieldsCustomProperties;

		/// <summary>All names of fields mapped onto a relation. Usable for in-memory filtering</summary>
		public static class MemberNames
		{
			/// <summary>Member name Employees</summary>
			public static readonly string Employees = "Employees";
			/// <summary>Member name Employees_</summary>
			public static readonly string Employees_ = "Employees_";
			/// <summary>Member name EmployeeTerritories</summary>
			public static readonly string EmployeeTerritories = "EmployeeTerritories";
			/// <summary>Member name Orders</summary>
			public static readonly string Orders = "Orders";
			/// <summary>Member name CustomersCollectionViaOrders</summary>
			public static readonly string CustomersCollectionViaOrders = "CustomersCollectionViaOrders";
			/// <summary>Member name ShippersCollectionViaOrders</summary>
			public static readonly string ShippersCollectionViaOrders = "ShippersCollectionViaOrders";
			/// <summary>Member name TerritoriesCollectionViaEmployeeTerritories</summary>
			public static readonly string TerritoriesCollectionViaEmployeeTerritories = "TerritoriesCollectionViaEmployeeTerritories";

		}
		#endregion
		
		/// <summary> Static CTor for setting up custom property hashtables. Is executed before the first instance of this entity class or derived classes is constructed. </summary>
		static EmployeesEntity()
		{
			SetupCustomPropertyHashtables();
		}

		/// <summary> CTor</summary>
		public EmployeesEntity():base("EmployeesEntity")
		{
			InitClassEmpty(null, CreateFields());
		}

		/// <summary> CTor</summary>
		/// <remarks>For framework usage.</remarks>
		/// <param name="fields">Fields object to set as the fields for this entity.</param>
		public EmployeesEntity(IEntityFields2 fields):base("EmployeesEntity")
		{
			InitClassEmpty(null, fields);
		}

		/// <summary> CTor</summary>
		/// <param name="validator">The custom validator object for this EmployeesEntity</param>
		public EmployeesEntity(IValidator validator):base("EmployeesEntity")
		{
			InitClassEmpty(validator, CreateFields());
		}
				

		/// <summary> CTor</summary>
		/// <param name="employeeId">PK value for Employees which data should be fetched into this Employees object</param>
		/// <remarks>The entity is not fetched by this constructor. Use a DataAccessAdapter for that.</remarks>
		public EmployeesEntity(System.Int32 employeeId):base("EmployeesEntity")
		{
			InitClassEmpty(null, CreateFields());
			this.EmployeeId = employeeId;
		}

		/// <summary> CTor</summary>
		/// <param name="employeeId">PK value for Employees which data should be fetched into this Employees object</param>
		/// <param name="validator">The custom validator object for this EmployeesEntity</param>
		/// <remarks>The entity is not fetched by this constructor. Use a DataAccessAdapter for that.</remarks>
		public EmployeesEntity(System.Int32 employeeId, IValidator validator):base("EmployeesEntity")
		{
			InitClassEmpty(validator, CreateFields());
			this.EmployeeId = employeeId;
		}

		/// <summary> Protected CTor for deserialization</summary>
		/// <param name="info"></param>
		/// <param name="context"></param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		protected EmployeesEntity(SerializationInfo info, StreamingContext context) : base(info, context)
		{
			if(SerializationHelper.Optimization != SerializationOptimization.Fast) 
			{
				_employees_ = (EntityCollection<EmployeesEntity>)info.GetValue("_employees_", typeof(EntityCollection<EmployeesEntity>));
				_employeeTerritories = (EntityCollection<EmployeeTerritoriesEntity>)info.GetValue("_employeeTerritories", typeof(EntityCollection<EmployeeTerritoriesEntity>));
				_orders = (EntityCollection<OrdersEntity>)info.GetValue("_orders", typeof(EntityCollection<OrdersEntity>));
				_customersCollectionViaOrders = (EntityCollection<CustomersEntity>)info.GetValue("_customersCollectionViaOrders", typeof(EntityCollection<CustomersEntity>));
				_shippersCollectionViaOrders = (EntityCollection<ShippersEntity>)info.GetValue("_shippersCollectionViaOrders", typeof(EntityCollection<ShippersEntity>));
				_territoriesCollectionViaEmployeeTerritories = (EntityCollection<TerritoriesEntity>)info.GetValue("_territoriesCollectionViaEmployeeTerritories", typeof(EntityCollection<TerritoriesEntity>));
				_employees = (EmployeesEntity)info.GetValue("_employees", typeof(EmployeesEntity));
				if(_employees!=null)
				{
					_employees.AfterSave+=new EventHandler(OnEntityAfterSave);
				}

				base.FixupDeserialization(FieldInfoProviderSingleton.GetInstance());
			}
			
			// __LLBLGENPRO_USER_CODE_REGION_START DeserializationConstructor
			// __LLBLGENPRO_USER_CODE_REGION_END
			
		}

		
		/// <summary>Performs the desync setup when an FK field has been changed. The entity referenced based on the FK field will be dereferenced and sync info will be removed.</summary>
		/// <param name="fieldIndex">The fieldindex.</param>
		protected override void PerformDesyncSetupFKFieldChange(int fieldIndex)
		{
			switch((EmployeesFieldIndex)fieldIndex)
			{
				case EmployeesFieldIndex.ReportsTo:
					DesetupSyncEmployees(true, false);
					break;
				default:
					base.PerformDesyncSetupFKFieldChange(fieldIndex);
					break;
			}
		}
				
		/// <summary>Gets the inheritance info provider instance of the project this entity instance is located in. </summary>
		/// <returns>ready to use inheritance info provider instance.</returns>
		protected override IInheritanceInfoProvider GetInheritanceInfoProvider()
		{
			return InheritanceInfoProviderSingleton.GetInstance();
		}
		
		/// <summary> Sets the related entity property to the entity specified. If the property is a collection, it will add the entity specified to that collection.</summary>
		/// <param name="propertyName">Name of the property.</param>
		/// <param name="entity">Entity to set as an related entity</param>
		/// <remarks>Used by prefetch path logic.</remarks>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public override void SetRelatedEntityProperty(string propertyName, IEntity2 entity)
		{
			switch(propertyName)
			{
				case "Employees":
					this.Employees = (EmployeesEntity)entity;
					break;
				case "Employees_":
					this.Employees_.Add((EmployeesEntity)entity);
					break;
				case "EmployeeTerritories":
					this.EmployeeTerritories.Add((EmployeeTerritoriesEntity)entity);
					break;
				case "Orders":
					this.Orders.Add((OrdersEntity)entity);
					break;
				case "CustomersCollectionViaOrders":
					this.CustomersCollectionViaOrders.IsReadOnly = false;
					this.CustomersCollectionViaOrders.Add((CustomersEntity)entity);
					this.CustomersCollectionViaOrders.IsReadOnly = true;
					break;
				case "ShippersCollectionViaOrders":
					this.ShippersCollectionViaOrders.IsReadOnly = false;
					this.ShippersCollectionViaOrders.Add((ShippersEntity)entity);
					this.ShippersCollectionViaOrders.IsReadOnly = true;
					break;
				case "TerritoriesCollectionViaEmployeeTerritories":
					this.TerritoriesCollectionViaEmployeeTerritories.IsReadOnly = false;
					this.TerritoriesCollectionViaEmployeeTerritories.Add((TerritoriesEntity)entity);
					this.TerritoriesCollectionViaEmployeeTerritories.IsReadOnly = true;
					break;

				default:
					break;
			}
		}
		
		/// <summary>Gets the relation objects which represent the relation the fieldName specified is mapped on. </summary>
		/// <param name="fieldName">Name of the field mapped onto the relation of which the relation objects have to be obtained.</param>
		/// <returns>RelationCollection with relation object(s) which represent the relation the field is maped on</returns>
		public override RelationCollection GetRelationsForFieldOfType(string fieldName)
		{
			return EmployeesEntity.GetRelationsForField(fieldName);
		}

		/// <summary>Gets the relation objects which represent the relation the fieldName specified is mapped on. </summary>
		/// <param name="fieldName">Name of the field mapped onto the relation of which the relation objects have to be obtained.</param>
		/// <returns>RelationCollection with relation object(s) which represent the relation the field is maped on</returns>
		public static RelationCollection GetRelationsForField(string fieldName)
		{
			RelationCollection toReturn = new RelationCollection();
			switch(fieldName)
			{
				case "Employees":
					toReturn.Add(EmployeesEntity.Relations.EmployeesEntityUsingEmployeeIdReportsTo);
					break;
				case "Employees_":
					toReturn.Add(EmployeesEntity.Relations.EmployeesEntityUsingReportsTo);
					break;
				case "EmployeeTerritories":
					toReturn.Add(EmployeesEntity.Relations.EmployeeTerritoriesEntityUsingEmployeeId);
					break;
				case "Orders":
					toReturn.Add(EmployeesEntity.Relations.OrdersEntityUsingEmployeeId);
					break;
				case "CustomersCollectionViaOrders":
					toReturn.Add(EmployeesEntity.Relations.OrdersEntityUsingEmployeeId, "EmployeesEntity__", "Orders_", JoinHint.None);
					toReturn.Add(OrdersEntity.Relations.CustomersEntityUsingCustomerId, "Orders_", string.Empty, JoinHint.None);
					break;
				case "ShippersCollectionViaOrders":
					toReturn.Add(EmployeesEntity.Relations.OrdersEntityUsingEmployeeId, "EmployeesEntity__", "Orders_", JoinHint.None);
					toReturn.Add(OrdersEntity.Relations.ShippersEntityUsingShipVia, "Orders_", string.Empty, JoinHint.None);
					break;
				case "TerritoriesCollectionViaEmployeeTerritories":
					toReturn.Add(EmployeesEntity.Relations.EmployeeTerritoriesEntityUsingEmployeeId, "EmployeesEntity__", "EmployeeTerritories_", JoinHint.None);
					toReturn.Add(EmployeeTerritoriesEntity.Relations.TerritoriesEntityUsingTerritoryId, "EmployeeTerritories_", string.Empty, JoinHint.None);
					break;

				default:

					break;				
			}
			return toReturn;
		}
#if !CF
		/// <summary>Checks if the relation mapped by the property with the name specified is a one way / single sided relation. If the passed in name is null, it
		/// will return true if the entity has any single-sided relation</summary>
		/// <param name="propertyName">Name of the property which is mapped onto the relation to check, or null to check if the entity has any relation/ which is single sided</param>
		/// <returns>true if the relation is single sided / one way (so the opposite relation isn't present), false otherwise</returns>
		[EditorBrowsable(EditorBrowsableState.Never)]
		protected override bool CheckOneWayRelations(string propertyName)
		{
			// use template trick to calculate the # of single-sided / oneway relations
			int numberOfOneWayRelations = 0;
			switch(propertyName)
			{
				case null:
					return ((numberOfOneWayRelations > 0) || base.CheckOneWayRelations(null));


				default:
					return base.CheckOneWayRelations(propertyName);
			}
		}
#endif
		/// <summary> Sets the internal parameter related to the fieldname passed to the instance relatedEntity. </summary>
		/// <param name="relatedEntity">Instance to set as the related entity of type entityType</param>
		/// <param name="fieldName">Name of field mapped onto the relation which resolves in the instance relatedEntity</param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public override void SetRelatedEntity(IEntity2 relatedEntity, string fieldName)
		{
			switch(fieldName)
			{
				case "Employees":
					SetupSyncEmployees(relatedEntity);
					break;
				case "Employees_":
					this.Employees_.Add((EmployeesEntity)relatedEntity);
					break;
				case "EmployeeTerritories":
					this.EmployeeTerritories.Add((EmployeeTerritoriesEntity)relatedEntity);
					break;
				case "Orders":
					this.Orders.Add((OrdersEntity)relatedEntity);
					break;

				default:
					break;
			}
		}

		/// <summary> Unsets the internal parameter related to the fieldname passed to the instance relatedEntity. Reverses the actions taken by SetRelatedEntity() </summary>
		/// <param name="relatedEntity">Instance to unset as the related entity of type entityType</param>
		/// <param name="fieldName">Name of field mapped onto the relation which resolves in the instance relatedEntity</param>
		/// <param name="signalRelatedEntityManyToOne">if set to true it will notify the manytoone side, if applicable.</param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public override void UnsetRelatedEntity(IEntity2 relatedEntity, string fieldName, bool signalRelatedEntityManyToOne)
		{
			switch(fieldName)
			{
				case "Employees":
					DesetupSyncEmployees(false, true);
					break;
				case "Employees_":
					base.PerformRelatedEntityRemoval(this.Employees_, relatedEntity, signalRelatedEntityManyToOne);
					break;
				case "EmployeeTerritories":
					base.PerformRelatedEntityRemoval(this.EmployeeTerritories, relatedEntity, signalRelatedEntityManyToOne);
					break;
				case "Orders":
					base.PerformRelatedEntityRemoval(this.Orders, relatedEntity, signalRelatedEntityManyToOne);
					break;

				default:
					break;
			}
		}

		/// <summary> Gets a collection of related entities referenced by this entity which depend on this entity (this entity is the PK side of their FK fields). These entities will have to be persisted after this entity during a recursive save.</summary>
		/// <returns>Collection with 0 or more IEntity2 objects, referenced by this entity</returns>
		public override List<IEntity2> GetDependingRelatedEntities()
		{
			List<IEntity2> toReturn = new List<IEntity2>();

			return toReturn;
		}
		
		/// <summary> Gets a collection of related entities referenced by this entity which this entity depends on (this entity is the FK side of their PK fields). These
		/// entities will have to be persisted before this entity during a recursive save.</summary>
		/// <returns>Collection with 0 or more IEntity2 objects, referenced by this entity</returns>
		public override List<IEntity2> GetDependentRelatedEntities()
		{
			List<IEntity2> toReturn = new List<IEntity2>();
			if(_employees!=null)
			{
				toReturn.Add(_employees);
			}

			return toReturn;
		}
		
		/// <summary>Gets a list of all entity collections stored as member variables in this entity. The contents of the ArrayList is used by the DataAccessAdapter to perform recursive saves. Only 1:n related collections are returned.</summary>
		/// <returns>Collection with 0 or more IEntityCollection2 objects, referenced by this entity</returns>
		public override List<IEntityCollection2> GetMemberEntityCollections()
		{
			List<IEntityCollection2> toReturn = new List<IEntityCollection2>();
			toReturn.Add(this.Employees_);
			toReturn.Add(this.EmployeeTerritories);
			toReturn.Add(this.Orders);

			return toReturn;
		}
		


		/// <summary>ISerializable member. Does custom serialization so event handlers do not get serialized. Serializes members of this entity class and uses the base class' implementation to serialize the rest.</summary>
		/// <param name="info"></param>
		/// <param name="context"></param>
		[EditorBrowsable(EditorBrowsableState.Never)]
		public override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			if (SerializationHelper.Optimization != SerializationOptimization.Fast) 
			{
				info.AddValue("_employees_", ((_employees_!=null) && (_employees_.Count>0) && !this.MarkedForDeletion)?_employees_:null);
				info.AddValue("_employeeTerritories", ((_employeeTerritories!=null) && (_employeeTerritories.Count>0) && !this.MarkedForDeletion)?_employeeTerritories:null);
				info.AddValue("_orders", ((_orders!=null) && (_orders.Count>0) && !this.MarkedForDeletion)?_orders:null);
				info.AddValue("_customersCollectionViaOrders", ((_customersCollectionViaOrders!=null) && (_customersCollectionViaOrders.Count>0) && !this.MarkedForDeletion)?_customersCollectionViaOrders:null);
				info.AddValue("_shippersCollectionViaOrders", ((_shippersCollectionViaOrders!=null) && (_shippersCollectionViaOrders.Count>0) && !this.MarkedForDeletion)?_shippersCollectionViaOrders:null);
				info.AddValue("_territoriesCollectionViaEmployeeTerritories", ((_territoriesCollectionViaEmployeeTerritories!=null) && (_territoriesCollectionViaEmployeeTerritories.Count>0) && !this.MarkedForDeletion)?_territoriesCollectionViaEmployeeTerritories:null);
				info.AddValue("_employees", (!this.MarkedForDeletion?_employees:null));

			}
			
			// __LLBLGENPRO_USER_CODE_REGION_START GetObjectInfo
			// __LLBLGENPRO_USER_CODE_REGION_END
			
			base.GetObjectData(info, context);
		}

		/// <summary>Returns true if the original value for the field with the fieldIndex passed in, read from the persistent storage was NULL, false otherwise.
		/// Should not be used for testing if the current value is NULL, use <see cref="TestCurrentFieldValueForNull"/> for that.</summary>
		/// <param name="fieldIndex">Index of the field to test if that field was NULL in the persistent storage</param>
		/// <returns>true if the field with the passed in index was NULL in the persistent storage, false otherwise</returns>
		public bool TestOriginalFieldValueForNull(EmployeesFieldIndex fieldIndex)
		{
			return base.Fields[(int)fieldIndex].IsNull;
		}
		
		/// <summary>Returns true if the current value for the field with the fieldIndex passed in represents null/not defined, false otherwise.
		/// Should not be used for testing if the original value (read from the db) is NULL</summary>
		/// <param name="fieldIndex">Index of the field to test if its currentvalue is null/undefined</param>
		/// <returns>true if the field's value isn't defined yet, false otherwise</returns>
		public bool TestCurrentFieldValueForNull(EmployeesFieldIndex fieldIndex)
		{
			return base.CheckIfCurrentFieldValueIsNull((int)fieldIndex);
		}

				
		/// <summary>Gets a list of all the EntityRelation objects the type of this instance has.</summary>
		/// <returns>A list of all the EntityRelation objects the type of this instance has. Hierarchy relations are excluded.</returns>
		public override List<IEntityRelation> GetAllRelations()
		{
			return new EmployeesRelations().GetAllRelations();
		}
		

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'Employees' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoEmployees_()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(EmployeesFields.ReportsTo, null, ComparisonOperator.Equal, this.EmployeeId));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'EmployeeTerritories' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoEmployeeTerritories()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(EmployeeTerritoriesFields.EmployeeId, null, ComparisonOperator.Equal, this.EmployeeId));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'Orders' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoOrders()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(OrdersFields.EmployeeId, null, ComparisonOperator.Equal, this.EmployeeId));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'Customers' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoCustomersCollectionViaOrders()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.Relations.AddRange(GetRelationsForFieldOfType("CustomersCollectionViaOrders"));
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(EmployeesFields.EmployeeId, null, ComparisonOperator.Equal, this.EmployeeId, "EmployeesEntity__"));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'Shippers' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoShippersCollectionViaOrders()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.Relations.AddRange(GetRelationsForFieldOfType("ShippersCollectionViaOrders"));
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(EmployeesFields.EmployeeId, null, ComparisonOperator.Equal, this.EmployeeId, "EmployeesEntity__"));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entities of type 'Territories' to this entity. Use DataAccessAdapter.FetchEntityCollection() to fetch these related entities.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoTerritoriesCollectionViaEmployeeTerritories()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.Relations.AddRange(GetRelationsForFieldOfType("TerritoriesCollectionViaEmployeeTerritories"));
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(EmployeesFields.EmployeeId, null, ComparisonOperator.Equal, this.EmployeeId, "EmployeesEntity__"));
			return bucket;
		}

		/// <summary> Creates a new IRelationPredicateBucket object which contains the predicate expression and relation collection to fetch
		/// the related entity of type 'Employees' to this entity. Use DataAccessAdapter.FetchNewEntity() to fetch this related entity.</summary>
		/// <returns></returns>
		public virtual IRelationPredicateBucket GetRelationInfoEmployees()
		{
			IRelationPredicateBucket bucket = new RelationPredicateBucket();
			bucket.PredicateExpression.Add(new FieldCompareValuePredicate(EmployeesFields.EmployeeId, null, ComparisonOperator.Equal, this.ReportsTo));
			return bucket;
		}

	
		
		/// <summary>Creates entity fields object for this entity. Used in constructor to setup this entity in a polymorphic scenario.</summary>
		protected virtual IEntityFields2 CreateFields()
		{
			return EntityFieldsFactory.CreateEntityFieldsObject(NorthwindAdapter.EntityType.EmployeesEntity);
		}

		/// <summary>
		/// Creates the ITypeDefaultValue instance used to provide default values for value types which aren't of type nullable(of T)
		/// </summary>
		/// <returns></returns>
		protected override ITypeDefaultValue CreateTypeDefaultValueProvider()
		{
			return new TypeDefaultValue();
		}

		/// <summary>Creates a new instance of the factory related to this entity</summary>
		protected override IEntityFactory2 CreateEntityFactory()
		{
			return EntityFactoryCache2.GetEntityFactory(typeof(EmployeesEntityFactory));
		}
#if !CF
		/// <summary>Adds the member collections to the collections queue (base first)</summary>
		/// <param name="collectionsQueue">The collections queue.</param>
		protected override void AddToMemberEntityCollectionsQueue(Queue<IEntityCollection2> collectionsQueue) 
		{
			base.AddToMemberEntityCollectionsQueue(collectionsQueue);
			collectionsQueue.Enqueue(this._employees_);
			collectionsQueue.Enqueue(this._employeeTerritories);
			collectionsQueue.Enqueue(this._orders);
			collectionsQueue.Enqueue(this._customersCollectionViaOrders);
			collectionsQueue.Enqueue(this._shippersCollectionViaOrders);
			collectionsQueue.Enqueue(this._territoriesCollectionViaEmployeeTerritories);
		}
		
		/// <summary>Gets the member collections queue from the queue (base first)</summary>
		/// <param name="collectionsQueue">The collections queue.</param>
		protected override void GetFromMemberEntityCollectionsQueue(Queue<IEntityCollection2> collectionsQueue)
		{
			base.GetFromMemberEntityCollectionsQueue(collectionsQueue);
			this._employees_ = (EntityCollection<EmployeesEntity>) collectionsQueue.Dequeue();
			this._employeeTerritories = (EntityCollection<EmployeeTerritoriesEntity>) collectionsQueue.Dequeue();
			this._orders = (EntityCollection<OrdersEntity>) collectionsQueue.Dequeue();
			this._customersCollectionViaOrders = (EntityCollection<CustomersEntity>) collectionsQueue.Dequeue();
			this._shippersCollectionViaOrders = (EntityCollection<ShippersEntity>) collectionsQueue.Dequeue();
			this._territoriesCollectionViaEmployeeTerritories = (EntityCollection<TerritoriesEntity>) collectionsQueue.Dequeue();
		}
		
		/// <summary>Determines whether the entity has populated member collections</summary>
		/// <returns>true if the entity has populated member collections.</returns>
		protected override bool HasPopulatedMemberEntityCollections()
		{
			if (this._employees_ != null)
			{
				return true;
			}
			if (this._employeeTerritories != null)
			{
				return true;
			}
			if (this._orders != null)
			{
				return true;
			}
			if (this._customersCollectionViaOrders != null)
			{
				return true;
			}
			if (this._shippersCollectionViaOrders != null)
			{
				return true;
			}
			if (this._territoriesCollectionViaEmployeeTerritories != null)
			{
				return true;
			}
			return base.HasPopulatedMemberEntityCollections();
		}
		
		/// <summary>Creates the member entity collections queue.</summary>
		/// <param name="collectionsQueue">The collections queue.</param>
		/// <param name="requiredQueue">The required queue.</param>
		protected override void CreateMemberEntityCollectionsQueue(Queue<IEntityCollection2> collectionsQueue, Queue<bool> requiredQueue) 
		{
			base.CreateMemberEntityCollectionsQueue(collectionsQueue, requiredQueue);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<EmployeesEntity>(EntityFactoryCache2.GetEntityFactory(typeof(EmployeesEntityFactory))) : null);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<EmployeeTerritoriesEntity>(EntityFactoryCache2.GetEntityFactory(typeof(EmployeeTerritoriesEntityFactory))) : null);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<OrdersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(OrdersEntityFactory))) : null);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<CustomersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CustomersEntityFactory))) : null);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<ShippersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(ShippersEntityFactory))) : null);
			collectionsQueue.Enqueue(requiredQueue.Dequeue() ? new EntityCollection<TerritoriesEntity>(EntityFactoryCache2.GetEntityFactory(typeof(TerritoriesEntityFactory))) : null);
		}
#endif
		/// <summary>
		/// Gets all related data objects, stored by name. The name is the field name mapped onto the relation for that particular data element. 
		/// </summary>
		/// <returns>Dictionary with per name the related referenced data element, which can be an entity collection or an entity or null</returns>
		public override Dictionary<string, object> GetRelatedData()
		{
			Dictionary<string, object> toReturn = new Dictionary<string, object>();
			toReturn.Add("Employees", _employees);
			toReturn.Add("Employees_", _employees_);
			toReturn.Add("EmployeeTerritories", _employeeTerritories);
			toReturn.Add("Orders", _orders);
			toReturn.Add("CustomersCollectionViaOrders", _customersCollectionViaOrders);
			toReturn.Add("ShippersCollectionViaOrders", _shippersCollectionViaOrders);
			toReturn.Add("TerritoriesCollectionViaEmployeeTerritories", _territoriesCollectionViaEmployeeTerritories);

			return toReturn;
		}
		
		/// <summary> Adds the internals to the active context. </summary>
		protected override void AddInternalsToContext()
		{
			if(_employees_!=null)
			{
				_employees_.ActiveContext = base.ActiveContext;
			}
			if(_employeeTerritories!=null)
			{
				_employeeTerritories.ActiveContext = base.ActiveContext;
			}
			if(_orders!=null)
			{
				_orders.ActiveContext = base.ActiveContext;
			}
			if(_customersCollectionViaOrders!=null)
			{
				_customersCollectionViaOrders.ActiveContext = base.ActiveContext;
			}
			if(_shippersCollectionViaOrders!=null)
			{
				_shippersCollectionViaOrders.ActiveContext = base.ActiveContext;
			}
			if(_territoriesCollectionViaEmployeeTerritories!=null)
			{
				_territoriesCollectionViaEmployeeTerritories.ActiveContext = base.ActiveContext;
			}
			if(_employees!=null)
			{
				_employees.ActiveContext = base.ActiveContext;
			}

		}

		/// <summary> Initializes the class members</summary>
		protected virtual void InitClassMembers()
		{

			_employees_ = null;
			_employeeTerritories = null;
			_orders = null;
			_customersCollectionViaOrders = null;
			_shippersCollectionViaOrders = null;
			_territoriesCollectionViaEmployeeTerritories = null;
			_employees = null;

			PerformDependencyInjection();
			
			// __LLBLGENPRO_USER_CODE_REGION_START InitClassMembers
			// __LLBLGENPRO_USER_CODE_REGION_END
			
			OnInitClassMembersComplete();
		}

		#region Custom Property Hashtable Setup
		/// <summary> Initializes the hashtables for the entity type and entity field custom properties. </summary>
		private static void SetupCustomPropertyHashtables()
		{
			_customProperties = new Dictionary<string, string>();
			_fieldsCustomProperties = new Dictionary<string, Dictionary<string, string>>();

			Dictionary<string, string> fieldHashtable = null;
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("EmployeeId", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("LastName", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("FirstName", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Title", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("TitleOfCourtesy", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("BirthDate", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("HireDate", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Address", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("City", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Region", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("PostalCode", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Country", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("HomePhone", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Extension", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Photo", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("Notes", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("ReportsTo", fieldHashtable);
			fieldHashtable = new Dictionary<string, string>();

			_fieldsCustomProperties.Add("PhotoPath", fieldHashtable);
		}
		#endregion

		/// <summary> Removes the sync logic for member _employees</summary>
		/// <param name="signalRelatedEntity">If set to true, it will call the related entity's UnsetRelatedEntity method</param>
		/// <param name="resetFKFields">if set to true it will also reset the FK fields pointing to the related entity</param>
		private void DesetupSyncEmployees(bool signalRelatedEntity, bool resetFKFields)
		{
			base.PerformDesetupSyncRelatedEntity( _employees, new PropertyChangedEventHandler( OnEmployeesPropertyChanged ), "Employees", EmployeesEntity.Relations.EmployeesEntityUsingEmployeeIdReportsTo, true, signalRelatedEntity, "Employees_", resetFKFields, new int[] { (int)EmployeesFieldIndex.ReportsTo } );		
			_employees = null;
		}

		/// <summary> setups the sync logic for member _employees</summary>
		/// <param name="relatedEntity">Instance to set as the related entity of type entityType</param>
		private void SetupSyncEmployees(IEntity2 relatedEntity)
		{
			if(_employees!=relatedEntity)
			{
				DesetupSyncEmployees(true, true);
				_employees = (EmployeesEntity)relatedEntity;
				base.PerformSetupSyncRelatedEntity( _employees, new PropertyChangedEventHandler( OnEmployeesPropertyChanged ), "Employees", EmployeesEntity.Relations.EmployeesEntityUsingEmployeeIdReportsTo, true, new string[] {  } );
			}
		}
		
		/// <summary>Handles property change events of properties in a related entity.</summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnEmployeesPropertyChanged( object sender, PropertyChangedEventArgs e )
		{
			switch( e.PropertyName )
			{
				default:
					break;
			}
		}


		/// <summary> Initializes the class with empty data, as if it is a new Entity.</summary>
		/// <param name="validator">The validator object for this EmployeesEntity</param>
		/// <param name="fields">Fields of this entity</param>
		protected virtual void InitClassEmpty(IValidator validator, IEntityFields2 fields)
		{
			OnInitializing();
			base.Fields = fields;
			base.IsNew=true;
			base.Validator = validator;
			InitClassMembers();

			
			// __LLBLGENPRO_USER_CODE_REGION_START InitClassEmpty
			// __LLBLGENPRO_USER_CODE_REGION_END
			

			OnInitialized();
		}

		#region Class Property Declarations
		/// <summary> The relations object holding all relations of this entity with other entity classes.</summary>
		public  static EmployeesRelations Relations
		{
			get	{ return new EmployeesRelations(); }
		}
		
		/// <summary> The custom properties for this entity type.</summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		public  static Dictionary<string, string> CustomProperties
		{
			get { return _customProperties;}
		}

		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'Employees' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathEmployees_
		{
			get
			{
				return new PrefetchPathElement2( new EntityCollection<EmployeesEntity>(EntityFactoryCache2.GetEntityFactory(typeof(EmployeesEntityFactory))),
					(IEntityRelation)GetRelationsForField("Employees_")[0], (int)NorthwindAdapter.EntityType.EmployeesEntity, (int)NorthwindAdapter.EntityType.EmployeesEntity, 0, null, null, null, null, "Employees_", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany);
			}
		}
		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'EmployeeTerritories' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathEmployeeTerritories
		{
			get
			{
				return new PrefetchPathElement2( new EntityCollection<EmployeeTerritoriesEntity>(EntityFactoryCache2.GetEntityFactory(typeof(EmployeeTerritoriesEntityFactory))),
					(IEntityRelation)GetRelationsForField("EmployeeTerritories")[0], (int)NorthwindAdapter.EntityType.EmployeesEntity, (int)NorthwindAdapter.EntityType.EmployeeTerritoriesEntity, 0, null, null, null, null, "EmployeeTerritories", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany);
			}
		}
		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'Orders' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathOrders
		{
			get
			{
				return new PrefetchPathElement2( new EntityCollection<OrdersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(OrdersEntityFactory))),
					(IEntityRelation)GetRelationsForField("Orders")[0], (int)NorthwindAdapter.EntityType.EmployeesEntity, (int)NorthwindAdapter.EntityType.OrdersEntity, 0, null, null, null, null, "Orders", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany);
			}
		}

		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'Customers' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathCustomersCollectionViaOrders
		{
			get
			{
				IEntityRelation intermediateRelation = EmployeesEntity.Relations.OrdersEntityUsingEmployeeId;
				intermediateRelation.SetAliases(string.Empty, "Orders_");
				return new PrefetchPathElement2(new EntityCollection<CustomersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CustomersEntityFactory))), intermediateRelation,
					(int)NorthwindAdapter.EntityType.EmployeesEntity, (int)NorthwindAdapter.EntityType.CustomersEntity, 0, null, null, GetRelationsForField("CustomersCollectionViaOrders"), null, "CustomersCollectionViaOrders", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToMany);
			}
		}

		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'Shippers' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathShippersCollectionViaOrders
		{
			get
			{
				IEntityRelation intermediateRelation = EmployeesEntity.Relations.OrdersEntityUsingEmployeeId;
				intermediateRelation.SetAliases(string.Empty, "Orders_");
				return new PrefetchPathElement2(new EntityCollection<ShippersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(ShippersEntityFactory))), intermediateRelation,
					(int)NorthwindAdapter.EntityType.EmployeesEntity, (int)NorthwindAdapter.EntityType.ShippersEntity, 0, null, null, GetRelationsForField("ShippersCollectionViaOrders"), null, "ShippersCollectionViaOrders", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToMany);
			}
		}

		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'Territories' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathTerritoriesCollectionViaEmployeeTerritories
		{
			get
			{
				IEntityRelation intermediateRelation = EmployeesEntity.Relations.EmployeeTerritoriesEntityUsingEmployeeId;
				intermediateRelation.SetAliases(string.Empty, "EmployeeTerritories_");
				return new PrefetchPathElement2(new EntityCollection<TerritoriesEntity>(EntityFactoryCache2.GetEntityFactory(typeof(TerritoriesEntityFactory))), intermediateRelation,
					(int)NorthwindAdapter.EntityType.EmployeesEntity, (int)NorthwindAdapter.EntityType.TerritoriesEntity, 0, null, null, GetRelationsForField("TerritoriesCollectionViaEmployeeTerritories"), null, "TerritoriesCollectionViaEmployeeTerritories", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToMany);
			}
		}

		/// <summary> Creates a new PrefetchPathElement2 object which contains all the information to prefetch the related entities of type 'Employees' 
		/// for this entity. Add the object returned by this property to an existing PrefetchPath2 instance.</summary>
		/// <returns>Ready to use IPrefetchPathElement2 implementation.</returns>
		public static IPrefetchPathElement2 PrefetchPathEmployees
		{
			get
			{
				return new PrefetchPathElement2(new EntityCollection(EntityFactoryCache2.GetEntityFactory(typeof(EmployeesEntityFactory))),
					(IEntityRelation)GetRelationsForField("Employees")[0], (int)NorthwindAdapter.EntityType.EmployeesEntity, (int)NorthwindAdapter.EntityType.EmployeesEntity, 0, null, null, null, null, "Employees", SD.LLBLGen.Pro.ORMSupportClasses.RelationType.ManyToOne);
			}
		}


		/// <summary> The custom properties for the type of this entity instance.</summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		[Browsable(false), XmlIgnore]
		public override Dictionary<string, string> CustomPropertiesOfType
		{
			get { return EmployeesEntity.CustomProperties;}
		}

		/// <summary> The custom properties for the fields of this entity type. The returned Hashtable contains per fieldname a hashtable of name-value
		/// pairs. </summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		public  static Dictionary<string, Dictionary<string, string>> FieldsCustomProperties
		{
			get { return _fieldsCustomProperties;}
		}

		/// <summary> The custom properties for the fields of the type of this entity instance. The returned Hashtable contains per fieldname a hashtable of name-value pairs. </summary>
		/// <remarks>The data returned from this property should be considered read-only: it is not thread safe to alter this data at runtime.</remarks>
		[Browsable(false), XmlIgnore]
		public override Dictionary<string, Dictionary<string, string>> FieldsCustomPropertiesOfType
		{
			get { return EmployeesEntity.FieldsCustomProperties;}
		}

		/// <summary> The EmployeeId property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."EmployeeID"<br/>
		/// Table field type characteristics (type, precision, scale, length): Int, 10, 0, 0<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): false, true, true</remarks>
		public virtual System.Int32 EmployeeId
		{
			get { return (System.Int32)GetValue((int)EmployeesFieldIndex.EmployeeId, true); }
			set	{ SetValue((int)EmployeesFieldIndex.EmployeeId, value); }
		}

		/// <summary> The LastName property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."LastName"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 20<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): false, false, false</remarks>
		public virtual System.String LastName
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.LastName, true); }
			set	{ SetValue((int)EmployeesFieldIndex.LastName, value); }
		}

		/// <summary> The FirstName property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."FirstName"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 10<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): false, false, false</remarks>
		public virtual System.String FirstName
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.FirstName, true); }
			set	{ SetValue((int)EmployeesFieldIndex.FirstName, value); }
		}

		/// <summary> The Title property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."Title"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 30<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String Title
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.Title, true); }
			set	{ SetValue((int)EmployeesFieldIndex.Title, value); }
		}

		/// <summary> The TitleOfCourtesy property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."TitleOfCourtesy"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 25<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String TitleOfCourtesy
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.TitleOfCourtesy, true); }
			set	{ SetValue((int)EmployeesFieldIndex.TitleOfCourtesy, value); }
		}

		/// <summary> The BirthDate property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."BirthDate"<br/>
		/// Table field type characteristics (type, precision, scale, length): DateTime, 0, 0, 0<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual Nullable<System.DateTime> BirthDate
		{
			get { return (Nullable<System.DateTime>)GetValue((int)EmployeesFieldIndex.BirthDate, false); }
			set	{ SetValue((int)EmployeesFieldIndex.BirthDate, value); }
		}

		/// <summary> The HireDate property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."HireDate"<br/>
		/// Table field type characteristics (type, precision, scale, length): DateTime, 0, 0, 0<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual Nullable<System.DateTime> HireDate
		{
			get { return (Nullable<System.DateTime>)GetValue((int)EmployeesFieldIndex.HireDate, false); }
			set	{ SetValue((int)EmployeesFieldIndex.HireDate, value); }
		}

		/// <summary> The Address property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."Address"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 60<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String Address
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.Address, true); }
			set	{ SetValue((int)EmployeesFieldIndex.Address, value); }
		}

		/// <summary> The City property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."City"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 15<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String City
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.City, true); }
			set	{ SetValue((int)EmployeesFieldIndex.City, value); }
		}

		/// <summary> The Region property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."Region"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 15<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String Region
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.Region, true); }
			set	{ SetValue((int)EmployeesFieldIndex.Region, value); }
		}

		/// <summary> The PostalCode property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."PostalCode"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 10<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String PostalCode
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.PostalCode, true); }
			set	{ SetValue((int)EmployeesFieldIndex.PostalCode, value); }
		}

		/// <summary> The Country property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."Country"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 15<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String Country
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.Country, true); }
			set	{ SetValue((int)EmployeesFieldIndex.Country, value); }
		}

		/// <summary> The HomePhone property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."HomePhone"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 24<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String HomePhone
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.HomePhone, true); }
			set	{ SetValue((int)EmployeesFieldIndex.HomePhone, value); }
		}

		/// <summary> The Extension property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."Extension"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 4<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String Extension
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.Extension, true); }
			set	{ SetValue((int)EmployeesFieldIndex.Extension, value); }
		}

		/// <summary> The Photo property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."Photo"<br/>
		/// Table field type characteristics (type, precision, scale, length): Image, 0, 0, 2147483647<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.Byte[] Photo
		{
			get { return (System.Byte[])GetValue((int)EmployeesFieldIndex.Photo, true); }
			set	{ SetValue((int)EmployeesFieldIndex.Photo, value); }
		}

		/// <summary> The Notes property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."Notes"<br/>
		/// Table field type characteristics (type, precision, scale, length): NText, 0, 0, 1073741823<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String Notes
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.Notes, true); }
			set	{ SetValue((int)EmployeesFieldIndex.Notes, value); }
		}

		/// <summary> The ReportsTo property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."ReportsTo"<br/>
		/// Table field type characteristics (type, precision, scale, length): Int, 10, 0, 0<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual Nullable<System.Int32> ReportsTo
		{
			get { return (Nullable<System.Int32>)GetValue((int)EmployeesFieldIndex.ReportsTo, false); }
			set	{ SetValue((int)EmployeesFieldIndex.ReportsTo, value); }
		}

		/// <summary> The PhotoPath property of the Entity Employees<br/><br/>
		/// </summary>
		/// <remarks>Mapped on  table field: "Employees"."PhotoPath"<br/>
		/// Table field type characteristics (type, precision, scale, length): NVarChar, 0, 0, 255<br/>
		/// Table field behavior characteristics (is nullable, is PK, is identity): true, false, false</remarks>
		public virtual System.String PhotoPath
		{
			get { return (System.String)GetValue((int)EmployeesFieldIndex.PhotoPath, true); }
			set	{ SetValue((int)EmployeesFieldIndex.PhotoPath, value); }
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'EmployeesEntity' which are related to this entity via a relation of type '1:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(EmployeesEntity))]
		public virtual EntityCollection<EmployeesEntity> Employees_
		{
			get
			{
				if(_employees_==null)
				{
					_employees_ = new EntityCollection<EmployeesEntity>(EntityFactoryCache2.GetEntityFactory(typeof(EmployeesEntityFactory)));
					_employees_.SetContainingEntityInfo(this, "Employees");
				}
				return _employees_;
			}
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'EmployeeTerritoriesEntity' which are related to this entity via a relation of type '1:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(EmployeeTerritoriesEntity))]
		public virtual EntityCollection<EmployeeTerritoriesEntity> EmployeeTerritories
		{
			get
			{
				if(_employeeTerritories==null)
				{
					_employeeTerritories = new EntityCollection<EmployeeTerritoriesEntity>(EntityFactoryCache2.GetEntityFactory(typeof(EmployeeTerritoriesEntityFactory)));
					_employeeTerritories.SetContainingEntityInfo(this, "Employees");
				}
				return _employeeTerritories;
			}
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'OrdersEntity' which are related to this entity via a relation of type '1:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(OrdersEntity))]
		public virtual EntityCollection<OrdersEntity> Orders
		{
			get
			{
				if(_orders==null)
				{
					_orders = new EntityCollection<OrdersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(OrdersEntityFactory)));
					_orders.SetContainingEntityInfo(this, "Employees");
				}
				return _orders;
			}
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'CustomersEntity' which are related to this entity via a relation of type 'm:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(CustomersEntity))]
		public virtual EntityCollection<CustomersEntity> CustomersCollectionViaOrders
		{
			get
			{
				if(_customersCollectionViaOrders==null)
				{
					_customersCollectionViaOrders = new EntityCollection<CustomersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(CustomersEntityFactory)));
					_customersCollectionViaOrders.IsReadOnly=true;
				}
				return _customersCollectionViaOrders;
			}
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'ShippersEntity' which are related to this entity via a relation of type 'm:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(ShippersEntity))]
		public virtual EntityCollection<ShippersEntity> ShippersCollectionViaOrders
		{
			get
			{
				if(_shippersCollectionViaOrders==null)
				{
					_shippersCollectionViaOrders = new EntityCollection<ShippersEntity>(EntityFactoryCache2.GetEntityFactory(typeof(ShippersEntityFactory)));
					_shippersCollectionViaOrders.IsReadOnly=true;
				}
				return _shippersCollectionViaOrders;
			}
		}

		/// <summary> Gets the EntityCollection with the related entities of type 'TerritoriesEntity' which are related to this entity via a relation of type 'm:n'.
		/// If the EntityCollection hasn't been fetched yet, the collection returned will be empty.</summary>
		[TypeContainedAttribute(typeof(TerritoriesEntity))]
		public virtual EntityCollection<TerritoriesEntity> TerritoriesCollectionViaEmployeeTerritories
		{
			get
			{
				if(_territoriesCollectionViaEmployeeTerritories==null)
				{
					_territoriesCollectionViaEmployeeTerritories = new EntityCollection<TerritoriesEntity>(EntityFactoryCache2.GetEntityFactory(typeof(TerritoriesEntityFactory)));
					_territoriesCollectionViaEmployeeTerritories.IsReadOnly=true;
				}
				return _territoriesCollectionViaEmployeeTerritories;
			}
		}

		/// <summary> Gets / sets related entity of type 'EmployeesEntity' which has to be set using a fetch action earlier. If no related entity
		/// is set for this property, null is returned. This property is not visible in databound grids.</summary>
		[Browsable(false)]
		public virtual EmployeesEntity Employees
		{
			get
			{
				return _employees;
			}
			set
			{
				if(base.IsDeserializing)
				{
					SetupSyncEmployees(value);
				}
				else
				{
					if(value==null)
					{
						if(_employees != null)
						{
							_employees.UnsetRelatedEntity(this, "Employees_");
						}
					}
					else
					{
						if(_employees!=value)
						{
							((IEntity2)value).SetRelatedEntity(this, "Employees_");
						}
					}
				}
			}
		}

	
		
		/// <summary> Gets the type of the hierarchy this entity is in. </summary>
		protected override InheritanceHierarchyType LLBLGenProIsInHierarchyOfType
		{
			get { return InheritanceHierarchyType.None;}
		}
		
		/// <summary> Gets or sets a value indicating whether this entity is a subtype</summary>
		protected override bool LLBLGenProIsSubType
		{
			get { return false;}
		}
		
		/// <summary>Returns the NorthwindAdapter.EntityType enum value for this entity.</summary>
		[Browsable(false), XmlIgnore]
		public override int LLBLGenProEntityTypeValue 
		{ 
			get { return (int)NorthwindAdapter.EntityType.EmployeesEntity; }
		}
		#endregion


		#region Custom Entity code
		
		// __LLBLGENPRO_USER_CODE_REGION_START CustomEntityCode
		// __LLBLGENPRO_USER_CODE_REGION_END
		
		#endregion

		#region Included code

		#endregion
	}
}
