﻿///////////////////////////////////////////////////////////////
// This is generated code. 
//////////////////////////////////////////////////////////////
// Code is generated using LLBLGen Pro version: 2.6
// Code is generated on: Friday, October 17, 2008 5:25:14 PM
// Code is generated using templates: SD.TemplateBindings.SqlServerSpecific.NET20
// Templates vendor: Solutions Design.
// Templates version: 
//////////////////////////////////////////////////////////////
using System;
using System.Collections;
using System.Data;

using SD.LLBLGen.Pro.ORMSupportClasses;

namespace NorthwindAdapter.DatabaseSpecific
{
	/// <summary>
	/// Singleton implementation of the PersistenceInfoProvider. This class is the singleton wrapper through which the actual instance is retrieved.
	/// </summary>
	/// <remarks>It uses a single instance of an internal class. The access isn't marked with locks as the PersistenceInfoProviderBase class is threadsafe.</remarks>
	internal sealed class PersistenceInfoProviderSingleton
	{
		#region Class Member Declarations
		private static readonly IPersistenceInfoProvider _providerInstance = new PersistenceInfoProviderCore();
		#endregion
		
		/// <summary>private ctor to prevent instances of this class.</summary>
		private PersistenceInfoProviderSingleton()
		{
		}

		/// <summary>Dummy static constructor to make sure threadsafe initialization is performed.</summary>
		static PersistenceInfoProviderSingleton()
		{
		}

		/// <summary>Gets the singleton instance of the PersistenceInfoProviderCore</summary>
		/// <returns>Instance of the PersistenceInfoProvider.</returns>
		public static IPersistenceInfoProvider GetInstance()
		{
			return _providerInstance;
		}
	}

	/// <summary>Actual implementation of the PersistenceInfoProvider. Used by singleton wrapper.</summary>
	internal class PersistenceInfoProviderCore : PersistenceInfoProviderBase
	{
		/// <summary>Initializes a new instance of the <see cref="PersistenceInfoProviderCore"/> class.</summary>
		internal PersistenceInfoProviderCore()
		{
			Init();
		}

		/// <summary>Method which initializes the internal datastores with the structure of hierarchical types.</summary>
		private void Init()
		{
			base.InitClass((29 + 0));
			InitAlphabeticalListOfProductsEntityMappings();
			InitCategoriesEntityMappings();
			InitCategorySalesFor1997EntityMappings();
			InitCurrentProductListEntityMappings();
			InitCustomerAndSuppliersByCityEntityMappings();
			InitCustomerCustomerDemoEntityMappings();
			InitCustomerDemographicsEntityMappings();
			InitCustomersEntityMappings();
			InitEmployeesEntityMappings();
			InitEmployeeTerritoriesEntityMappings();
			InitInvoicesEntityMappings();
			InitOrderDetailsEntityMappings();
			InitOrderDetailsExtendedEntityMappings();
			InitOrdersEntityMappings();
			InitOrdersQryEntityMappings();
			InitOrderSubtotalsEntityMappings();
			InitProductsEntityMappings();
			InitProductsAboveAveragePriceEntityMappings();
			InitProductSalesFor1997EntityMappings();
			InitProductsByCategoryEntityMappings();
			InitQuarterlyOrdersEntityMappings();
			InitRegionEntityMappings();
			InitSalesByCategoryEntityMappings();
			InitSalesTotalsByAmountEntityMappings();
			InitShippersEntityMappings();
			InitSummaryOfSalesByQuarterEntityMappings();
			InitSummaryOfSalesByYearEntityMappings();
			InitSuppliersEntityMappings();
			InitTerritoriesEntityMappings();

		}


		/// <summary>Inits AlphabeticalListOfProductsEntity's mappings</summary>
		private void InitAlphabeticalListOfProductsEntityMappings()
		{
			base.AddElementMapping( "AlphabeticalListOfProductsEntity", "NORTHWIND", @"dbo", "Alphabetical list of products", 11 );
			base.AddElementFieldMapping( "AlphabeticalListOfProductsEntity", "ProductId", "ProductID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "AlphabeticalListOfProductsEntity", "ProductName", "ProductName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "AlphabeticalListOfProductsEntity", "SupplierId", "SupplierID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 2 );
			base.AddElementFieldMapping( "AlphabeticalListOfProductsEntity", "CategoryId", "CategoryID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 3 );
			base.AddElementFieldMapping( "AlphabeticalListOfProductsEntity", "QuantityPerUnit", "QuantityPerUnit", false, (int)SqlDbType.NVarChar, 20, 0, 0, false, "", null, typeof(System.String), 4 );
			base.AddElementFieldMapping( "AlphabeticalListOfProductsEntity", "UnitPrice", "UnitPrice", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 5 );
			base.AddElementFieldMapping( "AlphabeticalListOfProductsEntity", "UnitsInStock", "UnitsInStock", false, (int)SqlDbType.SmallInt, 0, 0, 5, false, "", null, typeof(System.Int16), 6 );
			base.AddElementFieldMapping( "AlphabeticalListOfProductsEntity", "UnitsOnOrder", "UnitsOnOrder", false, (int)SqlDbType.SmallInt, 0, 0, 5, false, "", null, typeof(System.Int16), 7 );
			base.AddElementFieldMapping( "AlphabeticalListOfProductsEntity", "ReorderLevel", "ReorderLevel", false, (int)SqlDbType.SmallInt, 0, 0, 5, false, "", null, typeof(System.Int16), 8 );
			base.AddElementFieldMapping( "AlphabeticalListOfProductsEntity", "Discontinued", "Discontinued", false, (int)SqlDbType.Bit, 0, 0, 0, false, "", null, typeof(System.Boolean), 9 );
			base.AddElementFieldMapping( "AlphabeticalListOfProductsEntity", "CategoryName", "CategoryName", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 10 );
		}
		/// <summary>Inits CategoriesEntity's mappings</summary>
		private void InitCategoriesEntityMappings()
		{
			base.AddElementMapping( "CategoriesEntity", "NORTHWIND", @"dbo", "Categories", 4 );
			base.AddElementFieldMapping( "CategoriesEntity", "CategoryId", "CategoryID", false, (int)SqlDbType.Int, 0, 0, 10, true, "SCOPE_IDENTITY()", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "CategoriesEntity", "CategoryName", "CategoryName", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "CategoriesEntity", "Description", "Description", true, (int)SqlDbType.NText, 1073741823, 0, 0, false, "", null, typeof(System.String), 2 );
			base.AddElementFieldMapping( "CategoriesEntity", "Picture", "Picture", true, (int)SqlDbType.Image, 2147483647, 0, 0, false, "", null, typeof(System.Byte[]), 3 );
		}
		/// <summary>Inits CategorySalesFor1997Entity's mappings</summary>
		private void InitCategorySalesFor1997EntityMappings()
		{
			base.AddElementMapping( "CategorySalesFor1997Entity", "NORTHWIND", @"dbo", "Category Sales for 1997", 2 );
			base.AddElementFieldMapping( "CategorySalesFor1997Entity", "CategoryName", "CategoryName", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 0 );
			base.AddElementFieldMapping( "CategorySalesFor1997Entity", "CategorySales", "CategorySales", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 1 );
		}
		/// <summary>Inits CurrentProductListEntity's mappings</summary>
		private void InitCurrentProductListEntityMappings()
		{
			base.AddElementMapping( "CurrentProductListEntity", "NORTHWIND", @"dbo", "Current Product List", 2 );
			base.AddElementFieldMapping( "CurrentProductListEntity", "ProductId", "ProductID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "CurrentProductListEntity", "ProductName", "ProductName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 1 );
		}
		/// <summary>Inits CustomerAndSuppliersByCityEntity's mappings</summary>
		private void InitCustomerAndSuppliersByCityEntityMappings()
		{
			base.AddElementMapping( "CustomerAndSuppliersByCityEntity", "NORTHWIND", @"dbo", "Customer and Suppliers by City", 4 );
			base.AddElementFieldMapping( "CustomerAndSuppliersByCityEntity", "City", "City", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 0 );
			base.AddElementFieldMapping( "CustomerAndSuppliersByCityEntity", "CompanyName", "CompanyName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "CustomerAndSuppliersByCityEntity", "ContactName", "ContactName", false, (int)SqlDbType.NVarChar, 30, 0, 0, false, "", null, typeof(System.String), 2 );
			base.AddElementFieldMapping( "CustomerAndSuppliersByCityEntity", "Relationship", "Relationship", false, (int)SqlDbType.VarChar, 9, 0, 0, false, "", null, typeof(System.String), 3 );
		}
		/// <summary>Inits CustomerCustomerDemoEntity's mappings</summary>
		private void InitCustomerCustomerDemoEntityMappings()
		{
			base.AddElementMapping( "CustomerCustomerDemoEntity", "NORTHWIND", @"dbo", "CustomerCustomerDemo", 2 );
			base.AddElementFieldMapping( "CustomerCustomerDemoEntity", "CustomerId", "CustomerID", false, (int)SqlDbType.NChar, 5, 0, 0, false, "", null, typeof(System.String), 0 );
			base.AddElementFieldMapping( "CustomerCustomerDemoEntity", "CustomerTypeId", "CustomerTypeID", false, (int)SqlDbType.NChar, 10, 0, 0, false, "", null, typeof(System.String), 1 );
		}
		/// <summary>Inits CustomerDemographicsEntity's mappings</summary>
		private void InitCustomerDemographicsEntityMappings()
		{
			base.AddElementMapping( "CustomerDemographicsEntity", "NORTHWIND", @"dbo", "CustomerDemographics", 2 );
			base.AddElementFieldMapping( "CustomerDemographicsEntity", "CustomerTypeId", "CustomerTypeID", false, (int)SqlDbType.NChar, 10, 0, 0, false, "", null, typeof(System.String), 0 );
			base.AddElementFieldMapping( "CustomerDemographicsEntity", "CustomerDesc", "CustomerDesc", true, (int)SqlDbType.NText, 1073741823, 0, 0, false, "", null, typeof(System.String), 1 );
		}
		/// <summary>Inits CustomersEntity's mappings</summary>
		private void InitCustomersEntityMappings()
		{
			base.AddElementMapping( "CustomersEntity", "NORTHWIND", @"dbo", "Customers", 12 );
			base.AddElementFieldMapping( "CustomersEntity", "CustomerId", "CustomerID", false, (int)SqlDbType.NChar, 5, 0, 0, false, "", null, typeof(System.String), 0 );
			base.AddElementFieldMapping( "CustomersEntity", "CompanyName", "CompanyName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "CustomersEntity", "ContactName", "ContactName", true, (int)SqlDbType.NVarChar, 30, 0, 0, false, "", null, typeof(System.String), 2 );
			base.AddElementFieldMapping( "CustomersEntity", "ContactTitle", "ContactTitle", true, (int)SqlDbType.NVarChar, 30, 0, 0, false, "", null, typeof(System.String), 3 );
			base.AddElementFieldMapping( "CustomersEntity", "Address", "Address", true, (int)SqlDbType.NVarChar, 60, 0, 0, false, "", null, typeof(System.String), 4 );
			base.AddElementFieldMapping( "CustomersEntity", "City", "City", true, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 5 );
			base.AddElementFieldMapping( "CustomersEntity", "Region", "Region", true, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 6 );
			base.AddElementFieldMapping( "CustomersEntity", "PostalCode", "PostalCode", true, (int)SqlDbType.NVarChar, 10, 0, 0, false, "", null, typeof(System.String), 7 );
			base.AddElementFieldMapping( "CustomersEntity", "Country", "Country", true, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 8 );
			base.AddElementFieldMapping( "CustomersEntity", "Phone", "Phone", true, (int)SqlDbType.NVarChar, 24, 0, 0, false, "", null, typeof(System.String), 9 );
			base.AddElementFieldMapping( "CustomersEntity", "Fax", "Fax", true, (int)SqlDbType.NVarChar, 24, 0, 0, false, "", null, typeof(System.String), 10 );
			base.AddElementFieldMapping( "CustomersEntity", "Bool", "Bool", true, (int)SqlDbType.Bit, 0, 0, 0, false, "", null, typeof(System.Boolean), 11 );
		}
		/// <summary>Inits EmployeesEntity's mappings</summary>
		private void InitEmployeesEntityMappings()
		{
			base.AddElementMapping( "EmployeesEntity", "NORTHWIND", @"dbo", "Employees", 18 );
			base.AddElementFieldMapping( "EmployeesEntity", "EmployeeId", "EmployeeID", false, (int)SqlDbType.Int, 0, 0, 10, true, "SCOPE_IDENTITY()", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "EmployeesEntity", "LastName", "LastName", false, (int)SqlDbType.NVarChar, 20, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "EmployeesEntity", "FirstName", "FirstName", false, (int)SqlDbType.NVarChar, 10, 0, 0, false, "", null, typeof(System.String), 2 );
			base.AddElementFieldMapping( "EmployeesEntity", "Title", "Title", true, (int)SqlDbType.NVarChar, 30, 0, 0, false, "", null, typeof(System.String), 3 );
			base.AddElementFieldMapping( "EmployeesEntity", "TitleOfCourtesy", "TitleOfCourtesy", true, (int)SqlDbType.NVarChar, 25, 0, 0, false, "", null, typeof(System.String), 4 );
			base.AddElementFieldMapping( "EmployeesEntity", "BirthDate", "BirthDate", true, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 5 );
			base.AddElementFieldMapping( "EmployeesEntity", "HireDate", "HireDate", true, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 6 );
			base.AddElementFieldMapping( "EmployeesEntity", "Address", "Address", true, (int)SqlDbType.NVarChar, 60, 0, 0, false, "", null, typeof(System.String), 7 );
			base.AddElementFieldMapping( "EmployeesEntity", "City", "City", true, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 8 );
			base.AddElementFieldMapping( "EmployeesEntity", "Region", "Region", true, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 9 );
			base.AddElementFieldMapping( "EmployeesEntity", "PostalCode", "PostalCode", true, (int)SqlDbType.NVarChar, 10, 0, 0, false, "", null, typeof(System.String), 10 );
			base.AddElementFieldMapping( "EmployeesEntity", "Country", "Country", true, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 11 );
			base.AddElementFieldMapping( "EmployeesEntity", "HomePhone", "HomePhone", true, (int)SqlDbType.NVarChar, 24, 0, 0, false, "", null, typeof(System.String), 12 );
			base.AddElementFieldMapping( "EmployeesEntity", "Extension", "Extension", true, (int)SqlDbType.NVarChar, 4, 0, 0, false, "", null, typeof(System.String), 13 );
			base.AddElementFieldMapping( "EmployeesEntity", "Photo", "Photo", true, (int)SqlDbType.Image, 2147483647, 0, 0, false, "", null, typeof(System.Byte[]), 14 );
			base.AddElementFieldMapping( "EmployeesEntity", "Notes", "Notes", true, (int)SqlDbType.NText, 1073741823, 0, 0, false, "", null, typeof(System.String), 15 );
			base.AddElementFieldMapping( "EmployeesEntity", "ReportsTo", "ReportsTo", true, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 16 );
			base.AddElementFieldMapping( "EmployeesEntity", "PhotoPath", "PhotoPath", true, (int)SqlDbType.NVarChar, 255, 0, 0, false, "", null, typeof(System.String), 17 );
		}
		/// <summary>Inits EmployeeTerritoriesEntity's mappings</summary>
		private void InitEmployeeTerritoriesEntityMappings()
		{
			base.AddElementMapping( "EmployeeTerritoriesEntity", "NORTHWIND", @"dbo", "EmployeeTerritories", 2 );
			base.AddElementFieldMapping( "EmployeeTerritoriesEntity", "EmployeeId", "EmployeeID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "EmployeeTerritoriesEntity", "TerritoryId", "TerritoryID", false, (int)SqlDbType.NVarChar, 20, 0, 0, false, "", null, typeof(System.String), 1 );
		}
		/// <summary>Inits InvoicesEntity's mappings</summary>
		private void InitInvoicesEntityMappings()
		{
			base.AddElementMapping( "InvoicesEntity", "NORTHWIND", @"dbo", "Invoices", 26 );
			base.AddElementFieldMapping( "InvoicesEntity", "ShipName", "ShipName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 0 );
			base.AddElementFieldMapping( "InvoicesEntity", "ShipAddress", "ShipAddress", false, (int)SqlDbType.NVarChar, 60, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "InvoicesEntity", "ShipCity", "ShipCity", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 2 );
			base.AddElementFieldMapping( "InvoicesEntity", "ShipRegion", "ShipRegion", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 3 );
			base.AddElementFieldMapping( "InvoicesEntity", "ShipPostalCode", "ShipPostalCode", false, (int)SqlDbType.NVarChar, 10, 0, 0, false, "", null, typeof(System.String), 4 );
			base.AddElementFieldMapping( "InvoicesEntity", "ShipCountry", "ShipCountry", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 5 );
			base.AddElementFieldMapping( "InvoicesEntity", "CustomerId", "CustomerID", false, (int)SqlDbType.NChar, 5, 0, 0, false, "", null, typeof(System.String), 6 );
			base.AddElementFieldMapping( "InvoicesEntity", "CustomerName", "CustomerName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 7 );
			base.AddElementFieldMapping( "InvoicesEntity", "Address", "Address", false, (int)SqlDbType.NVarChar, 60, 0, 0, false, "", null, typeof(System.String), 8 );
			base.AddElementFieldMapping( "InvoicesEntity", "City", "City", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 9 );
			base.AddElementFieldMapping( "InvoicesEntity", "Region", "Region", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 10 );
			base.AddElementFieldMapping( "InvoicesEntity", "PostalCode", "PostalCode", false, (int)SqlDbType.NVarChar, 10, 0, 0, false, "", null, typeof(System.String), 11 );
			base.AddElementFieldMapping( "InvoicesEntity", "Country", "Country", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 12 );
			base.AddElementFieldMapping( "InvoicesEntity", "Salesperson", "Salesperson", false, (int)SqlDbType.NVarChar, 31, 0, 0, false, "", null, typeof(System.String), 13 );
			base.AddElementFieldMapping( "InvoicesEntity", "OrderId", "OrderID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 14 );
			base.AddElementFieldMapping( "InvoicesEntity", "OrderDate", "OrderDate", false, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 15 );
			base.AddElementFieldMapping( "InvoicesEntity", "RequiredDate", "RequiredDate", false, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 16 );
			base.AddElementFieldMapping( "InvoicesEntity", "ShippedDate", "ShippedDate", false, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 17 );
			base.AddElementFieldMapping( "InvoicesEntity", "ShipperName", "ShipperName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 18 );
			base.AddElementFieldMapping( "InvoicesEntity", "ProductId", "ProductID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 19 );
			base.AddElementFieldMapping( "InvoicesEntity", "ProductName", "ProductName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 20 );
			base.AddElementFieldMapping( "InvoicesEntity", "UnitPrice", "UnitPrice", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 21 );
			base.AddElementFieldMapping( "InvoicesEntity", "Quantity", "Quantity", false, (int)SqlDbType.SmallInt, 0, 0, 5, false, "", null, typeof(System.Int16), 22 );
			base.AddElementFieldMapping( "InvoicesEntity", "Discount", "Discount", false, (int)SqlDbType.Real, 0, 0, 24, false, "", null, typeof(System.Single), 23 );
			base.AddElementFieldMapping( "InvoicesEntity", "ExtendedPrice", "ExtendedPrice", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 24 );
			base.AddElementFieldMapping( "InvoicesEntity", "Freight", "Freight", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 25 );
		}
		/// <summary>Inits OrderDetailsEntity's mappings</summary>
		private void InitOrderDetailsEntityMappings()
		{
			base.AddElementMapping( "OrderDetailsEntity", "NORTHWIND", @"dbo", "Order Details", 5 );
			base.AddElementFieldMapping( "OrderDetailsEntity", "OrderId", "OrderID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "OrderDetailsEntity", "ProductId", "ProductID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 1 );
			base.AddElementFieldMapping( "OrderDetailsEntity", "UnitPrice", "UnitPrice", false, (int)SqlDbType.Decimal, 0, 2, 5, false, "", null, typeof(System.Decimal), 2 );
			base.AddElementFieldMapping( "OrderDetailsEntity", "Quantity", "Quantity", false, (int)SqlDbType.SmallInt, 0, 0, 5, false, "", null, typeof(System.Int16), 3 );
			base.AddElementFieldMapping( "OrderDetailsEntity", "Discount", "Discount", false, (int)SqlDbType.Real, 0, 0, 24, false, "", null, typeof(System.Single), 4 );
		}
		/// <summary>Inits OrderDetailsExtendedEntity's mappings</summary>
		private void InitOrderDetailsExtendedEntityMappings()
		{
			base.AddElementMapping( "OrderDetailsExtendedEntity", "NORTHWIND", @"dbo", "Order Details Extended", 7 );
			base.AddElementFieldMapping( "OrderDetailsExtendedEntity", "OrderId", "OrderID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "OrderDetailsExtendedEntity", "ProductId", "ProductID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 1 );
			base.AddElementFieldMapping( "OrderDetailsExtendedEntity", "ProductName", "ProductName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 2 );
			base.AddElementFieldMapping( "OrderDetailsExtendedEntity", "UnitPrice", "UnitPrice", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 3 );
			base.AddElementFieldMapping( "OrderDetailsExtendedEntity", "Quantity", "Quantity", false, (int)SqlDbType.SmallInt, 0, 0, 5, false, "", null, typeof(System.Int16), 4 );
			base.AddElementFieldMapping( "OrderDetailsExtendedEntity", "Discount", "Discount", false, (int)SqlDbType.Real, 0, 0, 24, false, "", null, typeof(System.Single), 5 );
			base.AddElementFieldMapping( "OrderDetailsExtendedEntity", "ExtendedPrice", "ExtendedPrice", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 6 );
		}
		/// <summary>Inits OrdersEntity's mappings</summary>
		private void InitOrdersEntityMappings()
		{
			base.AddElementMapping( "OrdersEntity", "NORTHWIND", @"dbo", "Orders", 14 );
			base.AddElementFieldMapping( "OrdersEntity", "OrderId", "OrderID", false, (int)SqlDbType.Int, 0, 0, 10, true, "SCOPE_IDENTITY()", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "OrdersEntity", "CustomerId", "CustomerID", true, (int)SqlDbType.NChar, 5, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "OrdersEntity", "EmployeeId", "EmployeeID", true, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 2 );
			base.AddElementFieldMapping( "OrdersEntity", "OrderDate", "OrderDate", true, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 3 );
			base.AddElementFieldMapping( "OrdersEntity", "RequiredDate", "RequiredDate", true, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 4 );
			base.AddElementFieldMapping( "OrdersEntity", "ShippedDate", "ShippedDate", true, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 5 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipVia", "ShipVia", true, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 6 );
			base.AddElementFieldMapping( "OrdersEntity", "Freight", "Freight", true, (int)SqlDbType.Decimal, 0, 2, 6, false, "", null, typeof(System.Decimal), 7 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipName", "ShipName", true, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 8 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipAddress", "ShipAddress", true, (int)SqlDbType.NVarChar, 60, 0, 0, false, "", null, typeof(System.String), 9 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipCity", "ShipCity", true, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 10 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipRegion", "ShipRegion", true, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 11 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipPostalCode", "ShipPostalCode", true, (int)SqlDbType.NVarChar, 10, 0, 0, false, "", null, typeof(System.String), 12 );
			base.AddElementFieldMapping( "OrdersEntity", "ShipCountry", "ShipCountry", true, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 13 );
		}
		/// <summary>Inits OrdersQryEntity's mappings</summary>
		private void InitOrdersQryEntityMappings()
		{
			base.AddElementMapping( "OrdersQryEntity", "NORTHWIND", @"dbo", "Orders Qry", 20 );
			base.AddElementFieldMapping( "OrdersQryEntity", "OrderId", "OrderID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "OrdersQryEntity", "CustomerId", "CustomerID", false, (int)SqlDbType.NChar, 5, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "OrdersQryEntity", "EmployeeId", "EmployeeID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 2 );
			base.AddElementFieldMapping( "OrdersQryEntity", "OrderDate", "OrderDate", false, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 3 );
			base.AddElementFieldMapping( "OrdersQryEntity", "RequiredDate", "RequiredDate", false, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 4 );
			base.AddElementFieldMapping( "OrdersQryEntity", "ShippedDate", "ShippedDate", false, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 5 );
			base.AddElementFieldMapping( "OrdersQryEntity", "ShipVia", "ShipVia", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 6 );
			base.AddElementFieldMapping( "OrdersQryEntity", "Freight", "Freight", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 7 );
			base.AddElementFieldMapping( "OrdersQryEntity", "ShipName", "ShipName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 8 );
			base.AddElementFieldMapping( "OrdersQryEntity", "ShipAddress", "ShipAddress", false, (int)SqlDbType.NVarChar, 60, 0, 0, false, "", null, typeof(System.String), 9 );
			base.AddElementFieldMapping( "OrdersQryEntity", "ShipCity", "ShipCity", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 10 );
			base.AddElementFieldMapping( "OrdersQryEntity", "ShipRegion", "ShipRegion", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 11 );
			base.AddElementFieldMapping( "OrdersQryEntity", "ShipPostalCode", "ShipPostalCode", false, (int)SqlDbType.NVarChar, 10, 0, 0, false, "", null, typeof(System.String), 12 );
			base.AddElementFieldMapping( "OrdersQryEntity", "ShipCountry", "ShipCountry", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 13 );
			base.AddElementFieldMapping( "OrdersQryEntity", "CompanyName", "CompanyName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 14 );
			base.AddElementFieldMapping( "OrdersQryEntity", "Address", "Address", false, (int)SqlDbType.NVarChar, 60, 0, 0, false, "", null, typeof(System.String), 15 );
			base.AddElementFieldMapping( "OrdersQryEntity", "City", "City", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 16 );
			base.AddElementFieldMapping( "OrdersQryEntity", "Region", "Region", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 17 );
			base.AddElementFieldMapping( "OrdersQryEntity", "PostalCode", "PostalCode", false, (int)SqlDbType.NVarChar, 10, 0, 0, false, "", null, typeof(System.String), 18 );
			base.AddElementFieldMapping( "OrdersQryEntity", "Country", "Country", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 19 );
		}
		/// <summary>Inits OrderSubtotalsEntity's mappings</summary>
		private void InitOrderSubtotalsEntityMappings()
		{
			base.AddElementMapping( "OrderSubtotalsEntity", "NORTHWIND", @"dbo", "Order Subtotals", 2 );
			base.AddElementFieldMapping( "OrderSubtotalsEntity", "OrderId", "OrderID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "OrderSubtotalsEntity", "Subtotal", "Subtotal", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 1 );
		}
		/// <summary>Inits ProductsEntity's mappings</summary>
		private void InitProductsEntityMappings()
		{
			base.AddElementMapping( "ProductsEntity", "NORTHWIND", @"dbo", "Products", 10 );
			base.AddElementFieldMapping( "ProductsEntity", "ProductId", "ProductID", false, (int)SqlDbType.Int, 0, 0, 10, true, "SCOPE_IDENTITY()", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "ProductsEntity", "ProductName", "ProductName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "ProductsEntity", "SupplierId", "SupplierID", true, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 2 );
			base.AddElementFieldMapping( "ProductsEntity", "CategoryId", "CategoryID", true, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 3 );
			base.AddElementFieldMapping( "ProductsEntity", "QuantityPerUnit", "QuantityPerUnit", true, (int)SqlDbType.NVarChar, 20, 0, 0, false, "", null, typeof(System.String), 4 );
			base.AddElementFieldMapping( "ProductsEntity", "UnitPrice", "UnitPrice", true, (int)SqlDbType.Decimal, 0, 2, 5, false, "", null, typeof(System.Decimal), 5 );
			base.AddElementFieldMapping( "ProductsEntity", "UnitsInStock", "UnitsInStock", true, (int)SqlDbType.SmallInt, 0, 0, 5, false, "", null, typeof(System.Int16), 6 );
			base.AddElementFieldMapping( "ProductsEntity", "UnitsOnOrder", "UnitsOnOrder", true, (int)SqlDbType.SmallInt, 0, 0, 5, false, "", null, typeof(System.Int16), 7 );
			base.AddElementFieldMapping( "ProductsEntity", "ReorderLevel", "ReorderLevel", true, (int)SqlDbType.SmallInt, 0, 0, 5, false, "", null, typeof(System.Int16), 8 );
			base.AddElementFieldMapping( "ProductsEntity", "Discontinued", "Discontinued", false, (int)SqlDbType.Bit, 0, 0, 0, false, "", null, typeof(System.Boolean), 9 );
		}
		/// <summary>Inits ProductsAboveAveragePriceEntity's mappings</summary>
		private void InitProductsAboveAveragePriceEntityMappings()
		{
			base.AddElementMapping( "ProductsAboveAveragePriceEntity", "NORTHWIND", @"dbo", "Products Above Average Price", 2 );
			base.AddElementFieldMapping( "ProductsAboveAveragePriceEntity", "ProductName", "ProductName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 0 );
			base.AddElementFieldMapping( "ProductsAboveAveragePriceEntity", "UnitPrice", "UnitPrice", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 1 );
		}
		/// <summary>Inits ProductSalesFor1997Entity's mappings</summary>
		private void InitProductSalesFor1997EntityMappings()
		{
			base.AddElementMapping( "ProductSalesFor1997Entity", "NORTHWIND", @"dbo", "Product Sales for 1997", 3 );
			base.AddElementFieldMapping( "ProductSalesFor1997Entity", "CategoryName", "CategoryName", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 0 );
			base.AddElementFieldMapping( "ProductSalesFor1997Entity", "ProductName", "ProductName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "ProductSalesFor1997Entity", "ProductSales", "ProductSales", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 2 );
		}
		/// <summary>Inits ProductsByCategoryEntity's mappings</summary>
		private void InitProductsByCategoryEntityMappings()
		{
			base.AddElementMapping( "ProductsByCategoryEntity", "NORTHWIND", @"dbo", "Products by Category", 5 );
			base.AddElementFieldMapping( "ProductsByCategoryEntity", "CategoryName", "CategoryName", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 0 );
			base.AddElementFieldMapping( "ProductsByCategoryEntity", "ProductName", "ProductName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "ProductsByCategoryEntity", "QuantityPerUnit", "QuantityPerUnit", false, (int)SqlDbType.NVarChar, 20, 0, 0, false, "", null, typeof(System.String), 2 );
			base.AddElementFieldMapping( "ProductsByCategoryEntity", "UnitsInStock", "UnitsInStock", false, (int)SqlDbType.SmallInt, 0, 0, 5, false, "", null, typeof(System.Int16), 3 );
			base.AddElementFieldMapping( "ProductsByCategoryEntity", "Discontinued", "Discontinued", false, (int)SqlDbType.Bit, 0, 0, 0, false, "", null, typeof(System.Boolean), 4 );
		}
		/// <summary>Inits QuarterlyOrdersEntity's mappings</summary>
		private void InitQuarterlyOrdersEntityMappings()
		{
			base.AddElementMapping( "QuarterlyOrdersEntity", "NORTHWIND", @"dbo", "Quarterly Orders", 4 );
			base.AddElementFieldMapping( "QuarterlyOrdersEntity", "CustomerId", "CustomerID", false, (int)SqlDbType.NChar, 5, 0, 0, false, "", null, typeof(System.String), 0 );
			base.AddElementFieldMapping( "QuarterlyOrdersEntity", "CompanyName", "CompanyName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "QuarterlyOrdersEntity", "City", "City", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 2 );
			base.AddElementFieldMapping( "QuarterlyOrdersEntity", "Country", "Country", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 3 );
		}
		/// <summary>Inits RegionEntity's mappings</summary>
		private void InitRegionEntityMappings()
		{
			base.AddElementMapping( "RegionEntity", "NORTHWIND", @"dbo", "Region", 2 );
			base.AddElementFieldMapping( "RegionEntity", "RegionId", "RegionID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "RegionEntity", "RegionDescription", "RegionDescription", false, (int)SqlDbType.NChar, 50, 0, 0, false, "", null, typeof(System.String), 1 );
		}
		/// <summary>Inits SalesByCategoryEntity's mappings</summary>
		private void InitSalesByCategoryEntityMappings()
		{
			base.AddElementMapping( "SalesByCategoryEntity", "NORTHWIND", @"dbo", "Sales by Category", 4 );
			base.AddElementFieldMapping( "SalesByCategoryEntity", "CategoryId", "CategoryID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "SalesByCategoryEntity", "CategoryName", "CategoryName", false, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "SalesByCategoryEntity", "ProductName", "ProductName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 2 );
			base.AddElementFieldMapping( "SalesByCategoryEntity", "ProductSales", "ProductSales", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 3 );
		}
		/// <summary>Inits SalesTotalsByAmountEntity's mappings</summary>
		private void InitSalesTotalsByAmountEntityMappings()
		{
			base.AddElementMapping( "SalesTotalsByAmountEntity", "NORTHWIND", @"dbo", "Sales Totals by Amount", 4 );
			base.AddElementFieldMapping( "SalesTotalsByAmountEntity", "SaleAmount", "SaleAmount", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 0 );
			base.AddElementFieldMapping( "SalesTotalsByAmountEntity", "OrderId", "OrderID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 1 );
			base.AddElementFieldMapping( "SalesTotalsByAmountEntity", "CompanyName", "CompanyName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 2 );
			base.AddElementFieldMapping( "SalesTotalsByAmountEntity", "ShippedDate", "ShippedDate", false, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 3 );
		}
		/// <summary>Inits ShippersEntity's mappings</summary>
		private void InitShippersEntityMappings()
		{
			base.AddElementMapping( "ShippersEntity", "NORTHWIND", @"dbo", "Shippers", 3 );
			base.AddElementFieldMapping( "ShippersEntity", "ShipperId", "ShipperID", false, (int)SqlDbType.Int, 0, 0, 10, true, "SCOPE_IDENTITY()", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "ShippersEntity", "CompanyName", "CompanyName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "ShippersEntity", "Phone", "Phone", true, (int)SqlDbType.NVarChar, 24, 0, 0, false, "", null, typeof(System.String), 2 );
		}
		/// <summary>Inits SummaryOfSalesByQuarterEntity's mappings</summary>
		private void InitSummaryOfSalesByQuarterEntityMappings()
		{
			base.AddElementMapping( "SummaryOfSalesByQuarterEntity", "NORTHWIND", @"dbo", "Summary of Sales by Quarter", 3 );
			base.AddElementFieldMapping( "SummaryOfSalesByQuarterEntity", "ShippedDate", "ShippedDate", false, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 0 );
			base.AddElementFieldMapping( "SummaryOfSalesByQuarterEntity", "OrderId", "OrderID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 1 );
			base.AddElementFieldMapping( "SummaryOfSalesByQuarterEntity", "Subtotal", "Subtotal", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 2 );
		}
		/// <summary>Inits SummaryOfSalesByYearEntity's mappings</summary>
		private void InitSummaryOfSalesByYearEntityMappings()
		{
			base.AddElementMapping( "SummaryOfSalesByYearEntity", "NORTHWIND", @"dbo", "Summary of Sales by Year", 3 );
			base.AddElementFieldMapping( "SummaryOfSalesByYearEntity", "ShippedDate", "ShippedDate", false, (int)SqlDbType.DateTime, 0, 0, 0, false, "", null, typeof(System.DateTime), 0 );
			base.AddElementFieldMapping( "SummaryOfSalesByYearEntity", "OrderId", "OrderID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 1 );
			base.AddElementFieldMapping( "SummaryOfSalesByYearEntity", "Subtotal", "Subtotal", false, (int)SqlDbType.Money, 0, 4, 19, false, "", null, typeof(System.Decimal), 2 );
		}
		/// <summary>Inits SuppliersEntity's mappings</summary>
		private void InitSuppliersEntityMappings()
		{
			base.AddElementMapping( "SuppliersEntity", "NORTHWIND", @"dbo", "Suppliers", 12 );
			base.AddElementFieldMapping( "SuppliersEntity", "SupplierId", "SupplierID", false, (int)SqlDbType.Int, 0, 0, 10, true, "SCOPE_IDENTITY()", null, typeof(System.Int32), 0 );
			base.AddElementFieldMapping( "SuppliersEntity", "CompanyName", "CompanyName", false, (int)SqlDbType.NVarChar, 40, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "SuppliersEntity", "ContactName", "ContactName", true, (int)SqlDbType.NVarChar, 30, 0, 0, false, "", null, typeof(System.String), 2 );
			base.AddElementFieldMapping( "SuppliersEntity", "ContactTitle", "ContactTitle", true, (int)SqlDbType.NVarChar, 30, 0, 0, false, "", null, typeof(System.String), 3 );
			base.AddElementFieldMapping( "SuppliersEntity", "Address", "Address", true, (int)SqlDbType.NVarChar, 60, 0, 0, false, "", null, typeof(System.String), 4 );
			base.AddElementFieldMapping( "SuppliersEntity", "City", "City", true, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 5 );
			base.AddElementFieldMapping( "SuppliersEntity", "Region", "Region", true, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 6 );
			base.AddElementFieldMapping( "SuppliersEntity", "PostalCode", "PostalCode", true, (int)SqlDbType.NVarChar, 10, 0, 0, false, "", null, typeof(System.String), 7 );
			base.AddElementFieldMapping( "SuppliersEntity", "Country", "Country", true, (int)SqlDbType.NVarChar, 15, 0, 0, false, "", null, typeof(System.String), 8 );
			base.AddElementFieldMapping( "SuppliersEntity", "Phone", "Phone", true, (int)SqlDbType.NVarChar, 24, 0, 0, false, "", null, typeof(System.String), 9 );
			base.AddElementFieldMapping( "SuppliersEntity", "Fax", "Fax", true, (int)SqlDbType.NVarChar, 24, 0, 0, false, "", null, typeof(System.String), 10 );
			base.AddElementFieldMapping( "SuppliersEntity", "HomePage", "HomePage", true, (int)SqlDbType.NText, 1073741823, 0, 0, false, "", null, typeof(System.String), 11 );
		}
		/// <summary>Inits TerritoriesEntity's mappings</summary>
		private void InitTerritoriesEntityMappings()
		{
			base.AddElementMapping( "TerritoriesEntity", "NORTHWIND", @"dbo", "Territories", 3 );
			base.AddElementFieldMapping( "TerritoriesEntity", "TerritoryId", "TerritoryID", false, (int)SqlDbType.NVarChar, 20, 0, 0, false, "", null, typeof(System.String), 0 );
			base.AddElementFieldMapping( "TerritoriesEntity", "TerritoryDescription", "TerritoryDescription", false, (int)SqlDbType.NChar, 50, 0, 0, false, "", null, typeof(System.String), 1 );
			base.AddElementFieldMapping( "TerritoriesEntity", "RegionId", "RegionID", false, (int)SqlDbType.Int, 0, 0, 10, false, "", null, typeof(System.Int32), 2 );
		}

	}
}













