﻿using System.Web.UI;
using NorthwindAdapter.DatabaseSpecific;
using SD.LLBLGen.Pro.ORMSupportClasses;

public partial class _Default : Page 
{
    protected void LLBLGenProDataSource2_PerformGetDbCount(object sender, PerformGetDbCountEventArgs2 e)
    {
        using (DataAccessAdapter adapter = new DataAccessAdapter())
        {
            e.DbCount = adapter.GetDbCount(e.ContainedCollection, e.Filter);
        }
    }

    protected void LLBLGenProDataSource2_PerformSelect(object sender, PerformSelectEventArgs2 e)
    {
        using (DataAccessAdapter adapter = new DataAccessAdapter())
        {
            adapter.FetchEntityCollection(e.ContainedCollection, e.Filter,
                    e.MaxNumberOfItemsToReturn, e.Sorter, e.PrefetchPath,
                    e.PageNumber, e.PageSize);
        }
    }

    protected void LLBLGenProDataSource2_PerformWork(object sender, PerformWorkEventArgs2 e)
    {
        using (DataAccessAdapter adapter = new DataAccessAdapter())
        {
            e.Uow.Commit(adapter, true);
        }
    }
}
